&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r11 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME WINDOW-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS WINDOW-1 
/*------------------------------------------------------------------------

  _update.w -- Roundtable Setup and Update

  Modify the variables at the top of the 'Definitions' section to suit
  your application.

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */


/* .......................................................................
   Change these values for your application.
....................................................................... */

/* Your application's name - displayed in various messages */
&GLOBAL APPLICATION-NAME Roundtable TSMS

/* Set this to NO for your application */
DEFINE VARIABLE Mroundtable   AS LOGICAL    INITIAL YES          NO-UNDO.

/* Your physical and logical database names - these are just defaults */
DEFINE VARIABLE Mdb_pname     AS CHARACTER INITIAL "rtb.db"     NO-UNDO.
DEFINE VARIABLE Mdb_lname     AS CHARACTER INITIAL "rtb"         NO-UNDO.

/* Your _update helpfile name. Leave blank if you don't have one. */
DEFINE VARIABLE Mhelpfile     AS CHARACTER INITIAL "" NO-UNDO.

/* .......................................................................
   You should not have to change anything from here down.
....................................................................... */



/* --- Define locals --- */       

DEFINE VARIABLE McurrentFrame AS HANDLE                          NO-UNDO.

DEFINE VARIABLE Mbranch       AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE Mrtb_instPath AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE Mdlc_path     AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE Mhelp         AS CHARACTER INITIAL ?             NO-UNDO.
DEFINE VARIABLE Merror        AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE MdbsInPf      AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE MdbsVer       AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE MdbCopies     AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE MverDir       AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE MnewVer       AS CHARACTER                       NO-UNDO.
DEFINE VARIABLE Mrxneeded     AS LOGICAL                         NO-UNDO.

DEFINE VARIABLE Mmsg          AS CHARACTER
   VIEW-AS EDITOR LARGE
   SIZE 70 BY 10
   SCROLLBAR-VERTICAL
   NO-UNDO.


DEFINE VARIABLE Mwin-title    AS CHARACTER
   INITIAL "{&APPLICATION-NAME} Setup and Update"
   NO-UNDO.
DEFINE VARIABLE Malert-title  AS CHARACTER 
   INITIAL "{&APPLICATION-NAME} Setup and Update"
   NO-UNDO.

   
/* --- Main dialog help. --- */
DEFINE VARIABLE Mcontext1     AS INTEGER INITIAL 1 NO-UNDO. 
/* --- Schema pf Entry dialog help. --- */
DEFINE VARIABLE Mcontext2     AS INTEGER INITIAL 1 NO-UNDO.
/* --- Compile pf Entry dialog help. --- */
DEFINE VARIABLE Mcontext3     AS INTEGER INITIAL 1 NO-UNDO.
DEFINE VARIABLE MdllError     AS INTEGER           NO-UNDO.
DEFINE VARIABLE Merror-status AS INTEGER           NO-UNDO.

DEFINE VARIABLE Mcancel        AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mcreate-dir    AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mcreate-file   AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mreturn-value  AS LOGICAL NO-UNDO.

DEFINE STREAM Sin.
DEFINE STREAM Sout.
DEFINE STREAM Sout1.
DEFINE STREAM Sin1.
DEFINE STREAM Sin2.

DEFINE WORKFILE Wcomp NO-UNDO
   FIELD object      AS CHARACTER
   FIELD rec-type    AS INTEGER
   FIELD comp-status AS CHARACTER
   FIELD comp-params AS CHARACTER
   FIELD save-into   AS CHARACTER.

DEFINE TEMP-TABLE Tselective-comp
   FIELD object AS CHARACTER.

DEFINE NEW SHARED TEMP-TABLE Tareas
   FIELD dbase      AS CHARACTER FORMAT "x(51)"
   FIELD table-name AS CHARACTER FORMAT "x(32)" LABEL "Table"
   FIELD object     AS CHARACTER FORMAT "x(40)" LABEL "Object"
   FIELD obj-type   AS CHARACTER                LABEL "Type"
   FIELD area-name  AS CHARACTER FORMAT "x(32)" LABEL "Area"
   FIELD df-file    AS CHARACTER.

/* --- 16/32 bit specifics --- */
&IF OPSYS = "win32" &THEN

  DEFINE VARIABLE Mprowin AS CHARACTER INITIAL "~/bin~/prowin32" NO-UNDO.

  PROCEDURE WinExec EXTERNAL "kernel32.dll":
    DEFINE INPUT  PARAMETER Pcmd     AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER Pwinstat AS LONG      NO-UNDO.
    DEFINE RETURN PARAMETER Perror   AS SHORT     NO-UNDO.
  END PROCEDURE.

&ELSE

  DEFINE VARIABLE Mprowin AS CHARACTER INITIAL "~/bin~/_prowin" NO-UNDO.

  PROCEDURE WinExec EXTERNAL "KRNL386.EXE":
    DEFINE INPUT PARAMETER Pcmd AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER Pwinstat AS SHORT NO-UNDO.
    DEFINE RETURN PARAMETER Perror AS SHORT NO-UNDO.
  END PROCEDURE.

&ENDIF
/* --- end 16/32 bit specifics --- */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE WINDOW
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME FRAME-DBEditPF

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BUTTON-New-pfentry EDITOR-PFFILE 
&Scoped-Define DISPLAYED-OBJECTS EDITOR-PFFILE 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnOsQuote WINDOW-1 
FUNCTION fnOsQuote RETURNS CHARACTER
  ( Parg AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR WINDOW-1 AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BUTTON-New-pfentry 
     LABEL "&pf Entry" 
     SIZE 10.6 BY 1.1.

DEFINE VARIABLE EDITOR-PFFILE AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 58 BY 4.38 NO-UNDO.

DEFINE BUTTON BUTTON-Browse 
     LABEL "B&rowse" 
     SIZE 9.6 BY 1.1.

DEFINE VARIABLE FILL-IN-schema-pf AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 53 BY 1 NO-UNDO.

DEFINE BUTTON BUTTON-Browse-2 
     LABEL "B&rowse" 
     SIZE 9.6 BY 1.1.

DEFINE VARIABLE FILL-IN-NewDBLoc AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 51 BY 1 NO-UNDO.

DEFINE BUTTON BT-DBAreas 
     LABEL "DB Areas..." 
     SIZE 14 BY 1.

DEFINE VARIABLE FILL-IN-Wait AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 22 BY .95 NO-UNDO.

DEFINE VARIABLE FILL-IN-dlc-path AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 53 BY 1 NO-UNDO.

DEFINE VARIABLE RADIO-SET-DBupdate AS INTEGER 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Create new local database", 1,
"Update schema of existing database", 2,
"Skip schema update", 3
     SIZE 61 BY 3.14 NO-UNDO.

DEFINE BUTTON Btn_Back 
     LABEL "<- &Back" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE BUTTON Btn_Finish AUTO-END-KEY 
     LABEL "&Finish" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE BUTTON Btn_Help 
     LABEL "&Help" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE BUTTON Btn_Next DEFAULT 
     LABEL "&Next ->" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE RECTANGLE RECT-8
     EDGE-PIXELS 1 GRAPHIC-EDGE  
     SIZE 80 BY .14
     BGCOLOR 0 .

DEFINE VARIABLE RADIO-SET-CompileType AS CHARACTER 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Full - All procedures", "F",
"Incremental - Only procedures affected by update", "I"
     SIZE 51.4 BY 1.86 NO-UNDO.

DEFINE VARIABLE TB-IgnoreWarnings AS LOGICAL INITIAL yes 
     LABEL "Ignore Warnings" 
     VIEW-AS TOGGLE-BOX
     SIZE 20.8 BY .81 NO-UNDO.

DEFINE BUTTON BUTTON-New-pfentry-2 
     LABEL "&pf Entry" 
     SIZE 10.6 BY 1.1.

DEFINE VARIABLE EDITOR-OBJPFFILE AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 58 BY 6 NO-UNDO.

DEFINE BUTTON BUTTON-Browse-3 
     LABEL "B&rowse" 
     SIZE 9.6 BY 1.1.

DEFINE VARIABLE FILL-IN-compile-pf AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 53 BY 1 NO-UNDO.

DEFINE VARIABLE FILL-IN-Rcode AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 53 BY 1 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME FRAME-OBJEditPF
     BUTTON-New-pfentry-2 AT ROW 8 COL 6
     EDITOR-OBJPFFILE AT ROW 8 COL 18 NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-OBJGetTarget
     FILL-IN-Rcode AT ROW 10 COL 13 COLON-ALIGNED NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-OBJGetPF
     FILL-IN-compile-pf AT ROW 12 COL 13 COLON-ALIGNED NO-LABEL
     BUTTON-Browse-3 AT ROW 12 COL 69
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-DBEditPF
     BUTTON-New-pfentry AT ROW 9 COL 3
     EDITOR-PFFILE AT ROW 9 COL 15 NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-Finish
     "Congratulations. You have completed your  Update." VIEW-AS TEXT
          SIZE 75 BY 1 AT ROW 3 COL 3
          FGCOLOR 9 FONT 1
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-DBLocal
     FILL-IN-NewDBLoc AT ROW 12 COL 13 COLON-ALIGNED NO-LABEL
     BUTTON-Browse-2 AT ROW 12 COL 67
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-DBGetPF
     FILL-IN-schema-pf AT ROW 12 COL 13 COLON-ALIGNED NO-LABEL
     BUTTON-Browse AT ROW 12 COL 69
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-DBUpdate
     BT-DBAreas AT ROW 12.91 COL 65
     FILL-IN-Wait AT ROW 12.91 COL 39 COLON-ALIGNED NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-Nav
     Btn_Back AT ROW 1.48 COL 5
     Btn_Next AT ROW 1.48 COL 18
     Btn_Finish AT ROW 1.48 COL 41
     Btn_Cancel AT ROW 1.48 COL 54
     Btn_Help AT ROW 1.48 COL 67
     RECT-8 AT ROW 1.14 COL 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 14.5
         SIZE 82 BY 2
         FONT 4
         DEFAULT-BUTTON Btn_Next.

DEFINE FRAME FRAME-Get-dlc-path
     FILL-IN-dlc-path AT ROW 10 COL 13 COLON-ALIGNED NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-Intro
     RADIO-SET-DBupdate AT ROW 10.52 COL 15 NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-Splash
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.

DEFINE FRAME FRAME-OBJCompile
     RADIO-SET-CompileType AT ROW 11.67 COL 4 NO-LABEL
     TB-IgnoreWarnings AT ROW 11.67 COL 59.8
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 82 BY 13.5
         FONT 4.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: WINDOW
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW WINDOW-1 ASSIGN
         HIDDEN             = YES
         TITLE              = "{&APPLICATION-NAME} Setup and Update"
         COLUMN             = 28.8
         ROW                = 9.86
         HEIGHT             = 15.29
         WIDTH              = 82
         MAX-HEIGHT         = 17.38
         MAX-WIDTH          = 82
         VIRTUAL-HEIGHT     = 17.38
         VIRTUAL-WIDTH      = 82
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW WINDOW-1
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME FRAME-DBEditPF
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-DBEditPF:HIDDEN           = TRUE.

ASSIGN 
       EDITOR-PFFILE:RETURN-INSERTED IN FRAME FRAME-DBEditPF  = TRUE.

/* SETTINGS FOR FRAME FRAME-DBGetPF
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-DBGetPF:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-DBLocal
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-DBLocal:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-DBUpdate
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-DBUpdate:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN FILL-IN-Wait IN FRAME FRAME-DBUpdate
   NO-ENABLE                                                            */
ASSIGN 
       FILL-IN-Wait:HIDDEN IN FRAME FRAME-DBUpdate           = TRUE.

/* SETTINGS FOR FRAME FRAME-Finish
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-Finish:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-Get-dlc-path
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-Get-dlc-path:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-Intro
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-Intro:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-Nav
                                                                        */
ASSIGN 
       FRAME FRAME-Nav:HIDDEN           = TRUE.

/* SETTINGS FOR BUTTON Btn_Back IN FRAME FRAME-Nav
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON Btn_Finish IN FRAME FRAME-Nav
   NO-ENABLE                                                            */
/* SETTINGS FOR RECTANGLE RECT-8 IN FRAME FRAME-Nav
   NO-ENABLE                                                            */
/* SETTINGS FOR FRAME FRAME-OBJCompile
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-OBJCompile:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-OBJEditPF
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-OBJEditPF:HIDDEN           = TRUE.

ASSIGN 
       EDITOR-OBJPFFILE:RETURN-INSERTED IN FRAME FRAME-OBJEditPF  = TRUE.

/* SETTINGS FOR FRAME FRAME-OBJGetPF
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-OBJGetPF:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-OBJGetTarget
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRAME-OBJGetTarget:HIDDEN           = TRUE.

/* SETTINGS FOR FRAME FRAME-Splash
                                                                        */
ASSIGN 
       FRAME FRAME-Splash:HIDDEN           = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WINDOW-1)
THEN WINDOW-1:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-DBEditPF
/* Query rebuild information for FRAME FRAME-DBEditPF
     _Query            is NOT OPENED
*/  /* FRAME FRAME-DBEditPF */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-DBGetPF
/* Query rebuild information for FRAME FRAME-DBGetPF
     _Query            is NOT OPENED
*/  /* FRAME FRAME-DBGetPF */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-DBLocal
/* Query rebuild information for FRAME FRAME-DBLocal
     _Query            is NOT OPENED
*/  /* FRAME FRAME-DBLocal */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-DBUpdate
/* Query rebuild information for FRAME FRAME-DBUpdate
     _Query            is NOT OPENED
*/  /* FRAME FRAME-DBUpdate */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-Finish
/* Query rebuild information for FRAME FRAME-Finish
     _Query            is NOT OPENED
*/  /* FRAME FRAME-Finish */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-Get-dlc-path
/* Query rebuild information for FRAME FRAME-Get-dlc-path
     _Query            is NOT OPENED
*/  /* FRAME FRAME-Get-dlc-path */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-Intro
/* Query rebuild information for FRAME FRAME-Intro
     _Query            is NOT OPENED
*/  /* FRAME FRAME-Intro */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-Nav
/* Query rebuild information for FRAME FRAME-Nav
     _Query            is NOT OPENED
*/  /* FRAME FRAME-Nav */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-OBJCompile
/* Query rebuild information for FRAME FRAME-OBJCompile
     _Query            is NOT OPENED
*/  /* FRAME FRAME-OBJCompile */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-OBJEditPF
/* Query rebuild information for FRAME FRAME-OBJEditPF
     _Query            is NOT OPENED
*/  /* FRAME FRAME-OBJEditPF */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-OBJGetPF
/* Query rebuild information for FRAME FRAME-OBJGetPF
     _Query            is NOT OPENED
*/  /* FRAME FRAME-OBJGetPF */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-OBJGetTarget
/* Query rebuild information for FRAME FRAME-OBJGetTarget
     _Query            is NOT OPENED
*/  /* FRAME FRAME-OBJGetTarget */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRAME-Splash
/* Query rebuild information for FRAME FRAME-Splash
     _Query            is NOT OPENED
*/  /* FRAME FRAME-Splash */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME FRAME-Nav
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL FRAME-Nav WINDOW-1
ON LEAVE OF FRAME FRAME-Nav
DO:
APPLY "ENTRY" TO Btn_Next IN FRAME FRAME-Nav. 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBUpdate
&Scoped-define SELF-NAME BT-DBAreas
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-DBAreas WINDOW-1
ON CHOOSE OF BT-DBAreas IN FRAME FRAME-DBUpdate /* DB Areas... */
DO:
  /* --- Show a simple wait message --- */
  ASSIGN FILL-IN-Wait:SCREEN-VALUE IN FRAME FRAME-DBUpdate = "Please Wait..."
         FILL-IN-Wait:VISIBLE IN FRAME FRAME-DBUpdate = TRUE.

  RUN assign_db_areas.

  /* --- Clear wait message --- */
  ASSIGN FILL-IN-Wait:SCREEN-VALUE IN FRAME FRAME-DBUpdate = ""
         FILL-IN-Wait:VISIBLE IN FRAME FRAME-DBUpdate = FALSE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-Nav
&Scoped-define SELF-NAME Btn_Back
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Back WINDOW-1
ON CHOOSE OF Btn_Back IN FRAME FRAME-Nav /* <- Back */
DO:
DEFINE VARIABLE MnextFrame AS HANDLE NO-UNDO.

CASE McurrentFrame:

  WHEN FRAME FRAME-Splash:HANDLE THEN .
  WHEN FRAME FRAME-get-dlc-path:HANDLE THEN MnextFrame = FRAME FRAME-Splash:HANDLE.
  WHEN FRAME FRAME-Intro:HANDLE THEN
     ASSIGN
        MnextFrame = IF SESSION:DISPLAY-TYPE = "TTY" THEN
                        FRAME FRAME-get-dlc-path:HANDLE
                     ELSE
                        FRAME FRAME-Splash:HANDLE.
  WHEN FRAME FRAME-DBLocal:HANDLE THEN MnextFrame = FRAME FRAME-Intro:HANDLE.
  WHEN FRAME FRAME-DBGetPF:HANDLE THEN 
     ASSIGN
        MnextFrame = IF Mbranch = "localdb" THEN
                        FRAME FRAME-DBLocal:HANDLE
                     ELSE
                        FRAME FRAME-Intro:HANDLE.
  WHEN FRAME FRAME-DBEditPF:HANDLE THEN MnextFrame = FRAME FRAME-DBGetPF:HANDLE.
  WHEN FRAME FRAME-DBUpdate:HANDLE THEN MnextFrame = FRAME FRAME-DBEditPF:HANDLE.

  WHEN FRAME FRAME-OBJGetPF:HANDLE THEN 
     CASE Mbranch:
         WHEN "localdb" THEN MnextFrame = FRAME FRAME-DBLocal:HANDLE.
         WHEN "schemaupdate" THEN MnextFrame = FRAME FRAME-DBUpdate:HANDLE.
         WHEN "skipschema" THEN MnextFrame = FRAME FRAME-Intro:HANDLE.
     END.
  WHEN FRAME FRAME-OBJEditPF:HANDLE THEN MnextFrame = FRAME FRAME-OBJGetPF:HANDLE.
  WHEN FRAME FRAME-OBJGetTarget:HANDLE THEN MnextFrame = FRAME FRAME-OBJEditPF:HANDLE.
 
  /*
  In the line below, remove the comments from around FRAME-OBJGetTarget and delete the 
  reference to FRAME-ObjEditPF to bring the R-Code directory frame back into the frame
  sequence. - Jeff Ledbetter
  */
  
  WHEN FRAME FRAME-OBJCompile:HANDLE THEN MnextFrame = FRAME /*FRAME-OBJGetTarget:HANDLE*/ FRAME-ObjEditPF:HANDLE.
  WHEN FRAME FRAME-Finish:HANDLE THEN MnextFrame = FRAME FRAME-OBJCompile:HANDLE.

END. /* CASE McurrentFrame */

IF MnextFrame <> ? THEN
   ASSIGN
   McurrentFrame:VISIBLE = NO
   McurrentFrame = MnextFrame
   MnextFrame:VISIBLE = YES.
   
Btn_Back:SENSITIVE = McurrentFrame:HANDLE <> FRAME FRAME-Splash:HANDLE.
Btn_Next:SENSITIVE = McurrentFrame:HANDLE <> FRAME FRAME-Finish:HANDLE.
Btn_Finish:SENSITIVE = McurrentFrame:HANDLE = FRAME FRAME-Finish:HANDLE.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Cancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel WINDOW-1
ON CHOOSE OF Btn_Cancel IN FRAME FRAME-Nav /* Cancel */
DO:
  DEFINE VARIABLE Myes AS LOGICAL NO-UNDO.
  MESSAGE 
     "Are you sure you want to exit the setup and update procedure?"
     VIEW-AS ALERT-BOX WARNING
     BUTTONS YES-NO
     TITLE Malert-title
     UPDATE Myes.
  IF Myes <> YES THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Finish
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Finish WINDOW-1
ON CHOOSE OF Btn_Finish IN FRAME FRAME-Nav /* Finish */
DO:
 APPLY "CLOSE" TO THIS-PROCEDURE.  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Help
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Help WINDOW-1
ON CHOOSE OF Btn_Help IN FRAME FRAME-Nav /* Help */
OR HELP OF FRAME {&FRAME-NAME}
DO: /* Call Help Function (or a simple message). */
  IF Mcontext1 <> 0 THEN
     SYSTEM-HELP Mhelp CONTEXT Mcontext1.
  ELSE
     MESSAGE
        "No Help defined for File: {&FILE-NAME}"
        VIEW-AS ALERT-BOX INFORMATION
        TITLE Malert-title.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Next
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Next WINDOW-1
ON CHOOSE OF Btn_Next IN FRAME FRAME-Nav /* Next -> */
DO:

DEFINE VARIABLE MnextFrame AS HANDLE NO-UNDO.
DEFINE VARIABLE Mhandle    AS HANDLE NO-UNDO.

ASSIGN
   MnextFrame = ?.


CASE McurrentFrame:


   WHEN FRAME FRAME-Splash:HANDLE THEN
      ASSIGN
         MnextFrame = IF SESSION:DISPLAY-TYPE = "TTY" THEN
                         FRAME FRAME-get-dlc-path:HANDLE
                      ELSE
                         FRAME FRAME-Intro:HANDLE.

                         
   WHEN FRAME FRAME-get-dlc-path:HANDLE THEN DO:

      /* --- Ensure progress directory is not blank. --- */
      IF FILL-IN-dlc-path:SCREEN-VALUE = "" THEN DO:
         MESSAGE
            "The PROGRESS directory cannot be left blank."
            SKIP(1)
            "Enter a PROGRESS directory."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         APPLY "ENTRY" TO FILL-IN-dlc-path.
         RETURN.
      END.  /* mdlc-path = "" */

      ASSIGN
         Mdlc_path = FILL-IN-dlc-path:SCREEN-VALUE
         Mdlc_path = REPLACE(Mdlc_path,"~\","~/").
      IF OPSYS = "UNIX" THEN
         Mdlc_path = REPLACE(Mdlc_path,"~\","~/").
      /* --- drop trailing slash --- */
      IF SUBSTRING(Mdlc_path,LENGTH(Mdlc_path),1) = "~/" OR
         SUBSTRING(Mdlc_path,LENGTH(Mdlc_path),1) = "~\" THEN
         ASSIGN
            Mdlc_path = SUBSTRING(Mdlc_path,1,LENGTH(Mdlc_path) - 1).

      /* --- Ensure bin/pro exists in the dlc directory entered. --- */
      IF (OPSYS = "UNIX" AND SEARCH(Mdlc_path + "~/bin~/pro") = ?) OR
         (OPSYS = "WIN32" AND SEARCH(Mdlc_path + "~\bin~\_progres.exe") = ?) 
      THEN DO:
         MESSAGE
            "The program required to execute PROGRESS "
            (IF OPSYS = "UNIX" THEN "'bin~/pro'" ELSE "'bin~\_progres'") +
            " was not found in the directory '"
            Mdlc_path +
            "' entered."
            SKIP(1)
            "Enter PROGRESS directory again."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         APPLY "ENTRY" TO FILL-IN-dlc-path.
         RETURN.
      END.  /* if search(mdlc-path ... */

      ASSIGN
         MnextFrame = FRAME FRAME-Intro:HANDLE.

   END.  /* when frame frame-get-dlc-path */

   
   WHEN FRAME FRAME-Intro:HANDLE THEN 
   
      CASE INTEGER(RADIO-SET-DBupdate:SCREEN-VALUE):
         WHEN 1 THEN
            ASSIGN
               MnextFrame = FRAME FRAME-DBLocal:HANDLE
               Mbranch    = "localdb".
          WHEN 2 THEN
             ASSIGN
                MnextFrame = FRAME FRAME-DBGetPF:HANDLE
                Mbranch    = "schemaupdate".
          WHEN 3 THEN
             ASSIGN
                MnextFrame = FRAME FRAME-OBJGetPF:HANDLE
                Mbranch    = "skipschema".
   
   END. /* CASE RADIO-SET-DBupdate */
   
      
   WHEN FRAME FRAME-DBLocal:HANDLE THEN DO:
      /* Create Local Database */
      RUN CreateLocalDatabase.
      IF RETURN-VALUE = "" THEN
         ASSIGN
            MnextFrame = FRAME FRAME-DBGetPF:HANDLE.
   END.  /* when frame frame-dblocal */
   
   
   WHEN FRAME FRAME-DBGetPF:HANDLE THEN DO:

      /* --- Load contents of the pf file --- */
      ASSIGN
         FILL-IN-schema-pf
         FILE-INFO:FILE-NAME = FILL-IN-schema-pf.

      IF FILE-INFO:FILE-NAME = "" THEN DO:
         MESSAGE
            "The Database Parameter File for schema update cannot be left blank."
            SKIP(1)
            "Enter a Database Parameter File."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         APPLY "ENTRY" TO FILL-IN-schema-pf.
         RETURN.
      END.  /* if file-info:file-name = "" */

      /* --- Create parameter file. --- */
      IF FILE-INFO:FULL-PATHNAME = ? THEN DO:        
      
         ASSIGN
            Mcreate-file = YES.
            
         MESSAGE 
            "Database Parameter File '" +
            FILE-INFO:FILE-NAME +
            "' for schema update does not exist."
            SKIP(1)
            "Do you wish to create it?"
            VIEW-AS ALERT-BOX WARNING
            BUTTONS YES-NO 
            TITLE Malert-title
            UPDATE Mcreate-file.

         IF Mcreate-file <> YES THEN
            RETURN.

         RUN makeDirectory(FILL-IN-schema-pf,OUTPUT Merror).

         IF Merror <> "" THEN DO:
            MESSAGE 
               "Cannot create directory to contain the new schema " +
               "Parameters file."
               SKIP(1)
               Merror
               VIEW-AS ALERT-BOX ERROR
              TITLE Malert-title.
            RETURN.
         END.  /* if merror <> "" */

        /* --- Create schema update parameter file --- */
        OUTPUT TO VALUE(FILL-IN-schema-pf) NO-ECHO.
        PUT UNFORMATTED "#schema update parameters file" SKIP.
        PUT UNFORMATTED "#release=EMPTY" SKIP.
        OUTPUT CLOSE.
        
        ASSIGN
           FILE-INFO:FILE-NAME = FILL-IN-schema-pf.
   
      END.  /* if file-info:pathname = "" */

      /* --- Load the contents of the pf file into the editor widget --- */
      ASSIGN
         Mreturn-value = EDITOR-PFFILE:READ-FILE(FILE-INFO:FULL-PATHNAME) IN FRAME FRAME-DBEditPF.

      IF NOT Mreturn-value THEN DO:
         MESSAGE
            "Could not read schema Parameters file '" +
            FILL-IN-schema-pf:SCREEN-VALUE +
            "'."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         RETURN.
      END.  /* if not mreturn-value */
      
      ASSIGN
         MnextFrame = FRAME FRAME-DBEditPF:HANDLE.
   
   END.  /* when frame frame-dbgetpf */   
                                       
   
   WHEN FRAME FRAME-DBEditPF:HANDLE THEN DO:
      
      /* --- ensure user has made at least one pf entry --- */
      RUN scanPfFile (INPUT  EDITOR-PFFILE:HANDLE IN FRAME FRAME-DBEditPF,
                      OUTPUT MdbsInPf,
                      OUTPUT MdbsVer,
                      OUTPUT MdbCopies,
                      OUTPUT Mrxneeded).

      IF NUM-ENTRIES(MdbsInPf) = 0 THEN DO:
         MESSAGE
            "The schema update Parameters File must have at least one pf " +
            "entry."
            SKIP(1)
            "Add a pf entry to the schema update Parameter File by either " +
            "editing the pf file with the editor or selecting the 'pf " +
            "Entry' button."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         RETURN.
      END.  /* if num-entries(mdbsinpf) = 0 */

      IF Mrxneeded THEN
        DO:
          RUN rx_message.
          RETURN.
        END.

      ASSIGN
         MnextFrame = FRAME FRAME-DBUpdate:HANDLE.
         
   END.  /* when frame frame-dbeditpf */
   
         
   WHEN FRAME FRAME-DBUpdate:HANDLE THEN DO:
      /* Update the schema of an existing database */
      RUN updateSchema.
      IF RETURN-VALUE = "" THEN
         ASSIGN
            MnextFrame = FRAME FRAME-OBJGetPF:HANDLE. 
   END.  /* when frame frame-dbupdate */
   
   
   WHEN FRAME FRAME-OBJGetPF:HANDLE THEN DO:
   
      /* --- Load contents of the pf file --- */
      ASSIGN
         FILL-IN-compile-pf
         FILE-INFO:FILE-NAME = FILL-IN-compile-pf.

      /* --- Ensure compile parameter file name is not blank. --- */
      IF FILE-INFO:FILE-NAME = "" THEN DO:
         MESSAGE
            "The compile Database Parameter File cannot be left blank."
            SKIP(1)
            "Enter a compile Database Parameter File."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         APPLY "ENTRY" TO FILL-IN-compile-pf.
         RETURN.
      END.  /* if file-info:file-name = "" */

      /* --- Create parameter file. --- */      
      IF FILE-INFO:FULL-PATHNAME = ? THEN DO:

         ASSIGN
            Mcreate-file = YES.
            
         MESSAGE 
            "Compile Database Parameter File '" +
            FILE-INFO:FILE-NAME +
            "' does not exist."
            SKIP(1)
            "Do you wish to create it?"
            VIEW-AS ALERT-BOX WARNING
            BUTTONS YES-NO 
            TITLE Malert-title
            UPDATE Mcreate-file.

         IF Mcreate-file <> YES THEN
            RETURN.

         RUN makeDirectory(FILL-IN-compile-pf,OUTPUT Merror).
         
         IF Merror <> "" THEN DO:
            MESSAGE 
               "Cannot create directory to contain the new compile " +
               "Parameters file."
               SKIP(1)
               Merror
               VIEW-AS ALERT-BOX ERROR
              TITLE Malert-title.
            RETURN.
         END.  /* if merror <> "" */

         /* --- Create compile update parameter file --- */
         OUTPUT TO VALUE(FILL-IN-compile-pf) NO-ECHO.
         PUT UNFORMATTED "#compile update parameters file" SKIP.
         OUTPUT CLOSE.

         ASSIGN
            FILE-INFO:FILE-NAME = FILL-IN-compile-pf.
   
      END.  /* if file-info:pathname = "" */

      /* --- Load the contents of the pf file into the editor widget. --- */
      ASSIGN
         Mreturn-value = EDITOR-OBJPFFILE:READ-FILE(FILE-INFO:FULL-PATHNAME) IN FRAME FRAME-OBJEditPF.

      IF NOT Mreturn-value THEN DO:
         MESSAGE
            "Could not read compile Parameters file '" +
            FILL-IN-schema-pf:SCREEN-VALUE +
            "'."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         RETURN.
      END.  /* if not mreturn-value */

      ASSIGN
         MnextFrame = FRAME FRAME-OBJEditPF:HANDLE.
         
   END.  /* when frame frame-objgetpf */
   
         
   WHEN FRAME FRAME-OBJEditPF:HANDLE THEN DO:
   
      /* --- ensure user has made at least one pf entry --- */
      RUN scanPfFile (INPUT  EDITOR-OBJPFFILE:HANDLE IN FRAME FRAME-OBJEditPF,
                      OUTPUT MdbsInPf,
                      OUTPUT MdbsVer,
                      OUTPUT MdbCopies,
                      OUTPUT Mrxneeded).

      IF NUM-ENTRIES(MdbsInPf) = 0 THEN DO:
         MESSAGE
            "The compile Parameters File must have at least one pf entry."
            SKIP(1)
            "Add a pf entry to the compile Parameter File by either " +
            "editing the pf file with the editor or selecting the 'pf " +
            "Entry' button."
            VIEW-AS ALERT-BOX ERROR
            TITLE Malert-title.
         RETURN.
      END.  /* if num-entries(mdbsinpf) = 0 */      

      /*
      In the line below, remove the comments from around FRAME-OBJGetTarget and delete the 
      reference to FRAME-ObjCompile to bring the R-Code directory frame back into the frame
      sequence. - Jeff Ledbetter
      */

      ASSIGN MnextFrame = FRAME /*FRAME-OBJGetTarget:HANDLE*/ FRAME-OBJCompile:HANDLE.
         
   END.  /* when frame frame-objeditpf */
   
         
   WHEN FRAME FRAME-OBJGetTarget:HANDLE THEN DO:
         
      IF FILL-IN-Rcode:SCREEN-VALUE <> "" THEN DO:
     
         /* --- Ensure target directory is a root directory. --- */
         IF (SUBSTRING(FILL-IN-Rcode:SCREEN-VALUE,2,1) = ":" AND
             SUBSTRING(FILL-IN-Rcode:SCREEN-VALUE,3,1) <> "~/" AND
             SUBSTRING(FILL-IN-Rcode:SCREEN-VALUE,3,1) <> "~\")
            OR
            (SUBSTRING(FILL-IN-Rcode:SCREEN-VALUE,2,1) <> ":" AND
             SUBSTRING(FILL-IN-Rcode:SCREEN-VALUE,1,1) <> "~/" AND
             SUBSTRING(FILL-IN-Rcode:SCREEN-VALUE,1,1) <> "~\") THEN DO:
            MESSAGE
               "The R-code Target directory must be a root directory."
               SKIP(1)
               "Enter the R-code Target directory again."
               VIEW-AS ALERT-BOX ERROR
               TITLE Malert-title.
            APPLY "ENTRY" TO FILL-IN-Rcode.
            RETURN.
         END.  /* if substring(fill-in-rcode ... */
   
         ASSIGN
            FILE-INFO:FILE-NAME = FILL-IN-Rcode:SCREEN-VALUE.
            
         /* --- create directory if it does not exist. --- */
         IF FILE-INFO:FULL-PATHNAME = ? THEN DO:
         
            ASSIGN
               Mcreate-dir = YES.
            
            MESSAGE
               "Directory '" +
               FILL-IN-Rcode:SCREEN-VALUE +
               "' does not exist."
               SKIP(1)
               "Do you wish to create it?"
               VIEW-AS ALERT-BOX WARNING
               BUTTONS YES-NO
               TITLE Malert-title
               UPDATE Mcreate-dir.
         
            IF Mcreate-dir THEN DO:
            
               OS-CREATE-DIR VALUE(FILL-IN-Rcode:SCREEN-VALUE).
           
               ASSIGN
                  Merror-status = OS-ERROR.
           
               IF Merror-status <> 0 THEN DO:
                  MESSAGE 
                     "Directory creation failed with OS error# "
                     Merror-status
                     "."
                     VIEW-AS ALERT-BOX WARNING
                     TITLE Malert-title.
                  APPLY "ENTRY" TO FILL-IN-Rcode.
                  RETURN.
               END.  /* if merror-status <> 0 */
                  
            END.  /* if mcreate-dir */
            ELSE DO:
               APPLY "ENTRY" TO FILL-IN-Rcode.
               RETURN.
            END.  /* if not mcreate-dir */         
         
         END.  /* file-info:full-pathname = ? */
         ELSE IF INDEX(FILE-INFO:FILE-TYPE, "D") = 0 THEN DO:
            MESSAGE 
               "The path specified is not a directory."
               VIEW-AS ALERT-BOX ERROR
               TITLE Malert-title.
            APPLY "ENTRY" TO FILL-IN-Rcode.            
            RETURN.
         END.  /* else if not file-info ... */
         
      END.  /* if fill-in-rcode:screen-value <> "" */
      
      ASSIGN 
         FILL-IN-Rcode
         MnextFrame    = FRAME FRAME-OBJCompile:HANDLE.
         
   END.  /* when frame frame-ibjgettarget */ 
   
         
   WHEN FRAME FRAME-OBJCompile:HANDLE THEN DO:
      /* Compile the application */
      /* Make sure the screen value is captured. */
      ASSIGN
         RADIO-SET-CompileType.
      IF RADIO-SET-CompileType = "F" THEN
         RUN CompileSource (INPUT "Full").
      IF RADIO-SET-CompileType = "I" THEN
         RUN CompileSource (INPUT "Incremental").
      IF RETURN-VALUE = "" THEN
         ASSIGN
            MnextFrame = FRAME FRAME-Finish:HANDLE.
   END.  /* when frame frame-objcompile */
   
END. /* CASE McurrentFrame */


IF MnextFrame <> ? THEN DO:
   ASSIGN
      McurrentFrame:VISIBLE = NO
      McurrentFrame         = MnextFrame
      MnextFrame:VISIBLE    = YES.
END.  /* if mnextframe <> ? */


ASSIGN
   Btn_Back:SENSITIVE   = McurrentFrame:HANDLE <> FRAME FRAME-Splash:HANDLE
   Btn_Next:SENSITIVE   = McurrentFrame:HANDLE <> FRAME FRAME-Finish:HANDLE
   Btn_Finish:SENSITIVE = McurrentFrame:HANDLE = FRAME FRAME-Finish:HANDLE.  


/* --- Put focus into the first tab item in the frame. --- */
IF McurrentFrame:HANDLE = FRAME FRAME-Finish:HANDLE THEN
   APPLY "ENTRY" TO Btn_Finish.
ELSE IF McurrentFrame:HANDLE = FRAME FRAME-DBUpdate:HANDLE THEN
   APPLY "ENTRY" TO Btn_Next.
ELSE DO:
   Mhandle = McurrentFrame:FIRST-CHILD. /* Get first field group in current frame */
   Mhandle = Mhandle:FIRST-TAB-ITEM.    /* Get first tab item in the field group */
   IF Mhandle <> ? THEN                 /* Make sure there is at least one tab item */
      APPLY "ENTRY" TO Mhandle.
END.  /* else do */


END.  /* choose Btn_next */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBGetPF
&Scoped-define SELF-NAME BUTTON-Browse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-Browse WINDOW-1
ON CHOOSE OF BUTTON-Browse IN FRAME FRAME-DBGetPF /* Browse */
DO:
DEFINE VARIABLE Mok AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mfilename AS CHARACTER NO-UNDO.

SYSTEM-DIALOG GET-FILE Mfilename
FILTERS "*.pf" "*.pf" INITIAL-FILTER 1
DEFAULT-EXTENSION ".pf"
TITLE "Get schema.pf parameters file"
UPDATE Mok.

IF NOT Mok THEN RETURN.

FILL-IN-schema-pf:SCREEN-VALUE = Mfilename.

APPLY "LEAVE" TO FILL-IN-schema-pf.  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBLocal
&Scoped-define SELF-NAME BUTTON-Browse-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-Browse-2 WINDOW-1
ON CHOOSE OF BUTTON-Browse-2 IN FRAME FRAME-DBLocal /* Browse */
DO:
DEFINE VARIABLE Mok AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mfilename AS CHARACTER NO-UNDO.

SYSTEM-DIALOG GET-FILE Mfilename
FILTERS "*.db" "*.db"
DEFAULT-EXTENSION ".db"
TITLE "Get new local database file location"
UPDATE Mok.

IF NOT Mok THEN RETURN.

FILL-IN-NewDBLoc:SCREEN-VALUE = Mfilename.

APPLY "LEAVE" TO FILL-IN-NewDBLoc.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-OBJGetPF
&Scoped-define SELF-NAME BUTTON-Browse-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-Browse-3 WINDOW-1
ON CHOOSE OF BUTTON-Browse-3 IN FRAME FRAME-OBJGetPF /* Browse */
DO:
DEFINE VARIABLE Mok AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mfilename AS CHARACTER NO-UNDO.

SYSTEM-DIALOG GET-FILE Mfilename
FILTERS "*.pf" "*.pf" INITIAL-FILTER 1
DEFAULT-EXTENSION ".pf"
TITLE "Get compile.pf parameters file"
UPDATE Mok.

IF NOT Mok THEN RETURN.

FILL-IN-compile-pf:SCREEN-VALUE = Mfilename.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBEditPF
&Scoped-define SELF-NAME BUTTON-New-pfentry
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-New-pfentry WINDOW-1
ON CHOOSE OF BUTTON-New-pfentry IN FRAME FRAME-DBEditPF /* pf Entry */
DO:
RUN CreatePFEntry (INPUT EDITOR-PFFILE:HANDLE IN FRAME FRAME-DBEditPF,
                   INPUT FILL-IN-schema-pf,
                   INPUT Mcontext2).
RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-OBJEditPF
&Scoped-define SELF-NAME BUTTON-New-pfentry-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-New-pfentry-2 WINDOW-1
ON CHOOSE OF BUTTON-New-pfentry-2 IN FRAME FRAME-OBJEditPF /* pf Entry */
DO: 
RUN CreatePFEntry (INPUT EDITOR-OBJPFFILE:HANDLE IN FRAME FRAME-OBJEditPF,
                   INPUT FILL-IN-compile-pf,
                   INPUT Mcontext3).
RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME EDITOR-OBJPFFILE
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL EDITOR-OBJPFFILE WINDOW-1
ON LEAVE OF EDITOR-OBJPFFILE IN FRAME FRAME-OBJEditPF
DO:

IF LAST-EVENT:WIDGET-ENTER = Btn_Cancel:HANDLE IN FRAME FRAME-Nav
   THEN Mreturn-value = EDITOR-OBJPFFILE:READ-FILE(FILL-IN-compile-pf).
   ELSE IF EDITOR-OBJPFFILE:MODIFIED THEN
           Mreturn-value = EDITOR-OBJPFFILE:SAVE-FILE(FILL-IN-compile-pf).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBEditPF
&Scoped-define SELF-NAME EDITOR-PFFILE
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL EDITOR-PFFILE WINDOW-1
ON LEAVE OF EDITOR-PFFILE IN FRAME FRAME-DBEditPF
DO:

IF LAST-EVENT:WIDGET-ENTER = Btn_Cancel:HANDLE IN FRAME FRAME-Nav 
   THEN Mreturn-value = EDITOR-PFFILE:READ-FILE(FILL-IN-schema-pf).
   ELSE IF EDITOR-PFFILE:MODIFIED THEN
           Mreturn-value = EDITOR-PFFILE:SAVE-FILE(FILL-IN-schema-pf).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBLocal
&Scoped-define SELF-NAME FILL-IN-NewDBLoc
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL FILL-IN-NewDBLoc WINDOW-1
ON LEAVE OF FILL-IN-NewDBLoc IN FRAME FRAME-DBLocal
DO:                                        
DEFINE VARIABLE Mstr AS CHARACTER NO-UNDO.
Mstr = TRIM(FILL-IN-NewDBLoc:SCREEN-VALUE).
IF Mstr <> "" AND (LENGTH(Mstr) < 3 OR SUBSTRING(Mstr,LENGTH(Mstr) - 2) <> ".db") THEN
   Mstr = Mstr + ".db".
FILL-IN-NewDBLoc:SCREEN-VALUE = Mstr.
ASSIGN FILL-IN-NewDBLoc.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-OBJCompile
&Scoped-define SELF-NAME RADIO-SET-CompileType
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RADIO-SET-CompileType WINDOW-1
ON VALUE-CHANGED OF RADIO-SET-CompileType IN FRAME FRAME-OBJCompile
DO:
ASSIGN RADIO-SET-CompileType.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FRAME-DBEditPF
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK WINDOW-1 


/* ***************************  Main Block  *************************** */

/* --- Initialize variables. --- */
IF Mhelp = ? THEN Mhelp = SEARCH("prohelp~/" + Mhelpfile).
IF Mhelp = ? THEN Mhelp = SEARCH(Mhelpfile).
IF Mhelp = ? THEN Mhelp = Mhelpfile.

ASSIGN
   Mrtb_instPath      = SESSION:TEMP-DIRECTORY + "rtb_inst~/"
   FILL-IN-dlc-path   = "/dlc"
   FILL-IN-schema-pf  = "schema.pf"
   FILL-IN-compile-pf = "compile.pf"
   FILL-IN-NewDBLoc   = Mdb_pname.

GET-KEY-VALUE SECTION "Startup" KEY "DLC" VALUE Mdlc_path.
IF OPSYS = "UNIX" THEN
ASSIGN
   Mdlc_path = REPLACE(Mdlc_path,"~\","~/").
/* --- drop trailing slash --- */
IF SUBSTRING(Mdlc_path,LENGTH(Mdlc_path),1) = "~/" OR
   SUBSTRING(Mdlc_path,LENGTH(Mdlc_path),1) = "~\" THEN
   ASSIGN
      Mdlc_path = SUBSTRING(Mdlc_path,1,LENGTH(Mdlc_path) - 1).

ASSIGN 
   EDITOR-OBJPFFILE:RETURN-INSERTED IN FRAME FRAME-OBJEditPF = TRUE.
   
/* --- Create a directory for install logs and error files. --- */
OS-CREATE-DIR "rtb_ilog".
ASSIGN
   Merror-status = OS-ERROR.
IF Merror-status <> 0 THEN
   MESSAGE
      "Installation log and error file directory 'rtb_ilog' could not be " +
      "created."
      SKIP(1)
      "Create this directory manually before continuing."
      VIEW-AS ALERT-BOX WARNING
      TITLE Malert-title.


ON ALT-R ANYWHERE
DO: 
   IF FRAME FRAME-DBGetPF:VISIBLE THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO BUTTON-BROWSE IN FRAME FRAME-DbGetPF.
      END.
   ELSE
   IF FRAME FRAME-DBLocal:VISIBLE THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO BUTTON-BROWSE-2 IN FRAME FRAME-DBLocal.
      END.
   ELSE
   IF FRAME FRAME-OBJGetPF:VISIBLE THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO BUTTON-BROWSE-3 IN FRAME FRAME-OBJGetPF.
      END.
   RETURN NO-APPLY.
END.

ON ALT-P ANYWHERE
DO:
   IF FRAME FRAME-DBEditPF:VISIBLE THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO BUTTON-New-pfentry IN FRAME FRAME-DBEditPF.
      END.
   ELSE
   IF FRAME FRAME-OBJEditPF:VISIBLE THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO BUTTON-New-pfentry-2 IN FRAME FRAME-OBJEditPF.
      END.
   RETURN NO-APPLY.   
END.

ON ALT-B ANYWHERE
DO:
   IF Btn_Back:SENSITIVE IN FRAME FRAME-NAV THEN 
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO Btn_Back.
      END.
   RETURN NO-APPLY.
END.

ON ALT-N ANYWHERE
DO:
   IF Btn_nEXT:SENSITIVE IN FRAME FRAME-NAV THEN
     DO:
     APPLY "LEAVE" TO SELF.
     APPLY "CHOOSE" TO Btn_Next.
     END.
   RETURN NO-APPLY.
END.

ON ALT-H ANYWHERE
DO:
   IF Btn_Help:SENSITIVE IN FRAME FRAME-NAV THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO Btn_Help.
      END.
   RETURN NO-APPLY.
END.

ON ALT-F ANYWHERE
DO:
   IF Btn_Finish:SENSITIVE IN FRAME FRAME-NAV THEN
      DO:
      APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO Btn_Finish.
      END.
   RETURN NO-APPLY.
END.

ON RETURN ANYWHERE
 
DO:
   DEFINE VARIABLE Mhandle AS WIDGET-HANDLE.

   IF SELF:TYPE = "EDITOR" AND SELF:VISIBLE THEN
      DO:
      IF SESSION:DISPLAY-TYPE = "TTY" THEN
         Mreturn-value = SELF:INSERT-STRING(CHR(10)).
      ELSE
         Mreturn-value = SELF:INSERT-STRING(CHR(13)).
      RETURN NO-APPLY.
      END.
   ELSE
   IF SELF:TYPE = "Button" AND SELF:VISIBLE THEN
      DO:
      APPLY "CHOOSE" TO SELF.
      RETURN NO-APPLY.
      END.

   ASSIGN
   Mhandle = SELF:HANDLE     /* widget */
   Mhandle = Mhandle:PARENT  /* fldgrp */
   Mhandle = Mhandle:PARENT. /* frame */

   /* The following statement makes sure that dialog boxes are handled 
      differently than frames belonging to the current window */
   IF 
   FRAME FRAME-DBEditPF:HANDLE <> Mhandle AND
   FRAME FRAME-DBGetPF:HANDLE <> Mhandle AND
   FRAME FRAME-DBLocal:HANDLE <> Mhandle AND
   FRAME FRAME-DBUpdate:HANDLE <> Mhandle AND
   FRAME FRAME-Finish:HANDLE <> Mhandle AND
   FRAME FRAME-Intro:HANDLE <> Mhandle AND
   FRAME FRAME-Nav:HANDLE <> Mhandle AND
   FRAME FRAME-OBJCompile:HANDLE <> Mhandle AND
   FRAME FRAME-OBJEditPF:HANDLE <> Mhandle AND
   FRAME FRAME-OBJGetPF:HANDLE <> Mhandle AND
   FRAME FRAME-OBJGetTarget:HANDLE <> Mhandle AND
   FRAME FRAME-Splash:HANDLE <> Mhandle
    THEN 
      DO:
      APPLY "GO" TO Mhandle.
      RETURN NO-APPLY.
      END.
      
   IF Btn_Next:SENSITIVE IN FRAME FRAME-NAV THEN
      DO:      
      IF SELF:VISIBLE THEN APPLY "LEAVE" TO SELF.
      APPLY "CHOOSE" TO Btn_Next.
      RETURN NO-APPLY.
      END.
      
   RETURN NO-APPLY. 
END.

ON TAB ANYWHERE DO:

   /* --- Determine if we are on the last widget in the current frame --- */
   DEFINE VARIABLE Mfldgrp      AS WIDGET-HANDLE.
   DEFINE VARIABLE Mframe       AS WIDGET-HANDLE.
   DEFINE VARIABLE Mwindow      AS WIDGET-HANDLE.
   DEFINE VARIABLE Mwidget      AS WIDGET-HANDLE.


   ASSIGN
      Mwidget      = SELF:HANDLE
      Mfldgrp      = Mwidget:PARENT
      Mframe       = Mfldgrp:PARENT
      Mwindow      = Mframe:PARENT.
                                  
   /* --- Don't want to control the Tabs in these frames. --- */
   IF Mframe:NAME = "update-frame" OR
      Mframe:NAME = "Compile-Status" OR
      Mframe:NAME = "selectiveComp-frame" OR
      Mframe:NAME = "Local-DB-options-frame" OR
      Mframe:NAME = "Remote-DB-options-frame" OR
      Mwidget:NAME = "area-name" THEN
      RETURN.
 
   /* --- Find the next tab item. --- */
   FRAME-LOOP:
   DO WHILE TRUE: /* Loop through frames */
      DO WHILE TRUE: /* Loop through field groups */
         DO WHILE TRUE: /* Loop through widgets */
         
            IF NOT VALID-HANDLE(Mwidget) THEN
               LEAVE.
            IF Mwidget:SENSITIVE AND
               Mwidget <> SELF:HANDLE AND
               Mwidget:VISIBLE THEN
               LEAVE FRAME-LOOP. /* found next tab item */
            ASSIGN
               Mwidget = Mwidget:NEXT-SIBLING.
            
         END.  /* do while true - widgets */

         ASSIGN
            Mfldgrp = Mfldgrp:NEXT-SIBLING.
         IF NOT VALID-HANDLE(Mfldgrp) THEN
            LEAVE.
         ASSIGN
            Mwidget = Mfldgrp:FIRST-CHILD.
         
      END.  /* do while true - field */
      
      ASSIGN
         Mframe = Mframe:NEXT-SIBLING.
      IF NOT VALID-HANDLE(Mframe) THEN
         Mframe = Mwindow:FIRST-CHILD.
      DO WHILE Mframe:HIDDEN:
         ASSIGN
            Mframe = Mframe:NEXT-SIBLING.
         IF NOT VALID-HANDLE(Mframe) THEN
            ASSIGN
              Mframe = Mwindow:FIRST-CHILD.
      END.  /* do while mframe:hidden */
      ASSIGN
         Mfldgrp = Mframe:FIRST-CHILD
         Mwidget = Mfldgrp:FIRST-CHILD.
      
   END.  /* do while true - frames */

   APPLY "ENTRY" TO Mwidget.
   RETURN NO-APPLY.

END.  /* on tab */

ON BACK-TAB ANYWHERE 
DO:
/* Determine if we are on the last widget in the current frame */
DEFINE VARIABLE Mfldgrp AS WIDGET-HANDLE.
DEFINE VARIABLE Mframe  AS WIDGET-HANDLE.
DEFINE VARIABLE Mwindow AS WIDGET-HANDLE.
DEFINE VARIABLE Mwidget AS WIDGET-HANDLE.

ASSIGN
Mwidget   = SELF:HANDLE
Mfldgrp   = Mwidget:PARENT
Mframe    = Mfldgrp:PARENT
Mwindow   = Mframe:PARENT.

   /* --- Don't want to control the Tabs in these frames. --- */
   IF Mframe:NAME = "update-frame" OR
      Mframe:NAME = "Compile-Status" OR
      Mframe:NAME = "selectiveComp-frame" OR
      Mframe:NAME = "Local-DB-options-frame" OR
      Mframe:NAME = "Remote-DB-options-frame" OR
      Mwidget:NAME = "area-name" THEN
      RETURN.

IF Mwidget:PREV-TAB-ITEM = ? THEN 
   DO: /* WE ARE AT THE END OF THE TAB CHAIN 
          IN THE CURRENT FRAME. FIND NEXT TAB ITEM */
   FRAME-LOOP:
   DO WHILE TRUE: /* Loop through frames */
      DO WHILE TRUE: /* Loop through field groups */
         DO WHILE TRUE: /* Loop through widgets */
            IF NOT VALID-HANDLE(Mwidget) THEN LEAVE.
            IF Mwidget:SENSITIVE 
            AND Mwidget <> SELF:HANDLE
            AND Mwidget:VISIBLE
               THEN LEAVE FRAME-LOOP. /* found next tab item */
            Mwidget = Mwidget:PREV-SIBLING.
         END.

         Mfldgrp = Mfldgrp:PREV-SIBLING.
         IF NOT VALID-HANDLE(Mfldgrp) THEN LEAVE.
         Mwidget = Mfldgrp:LAST-CHILD.
      END.

      
      Mframe = Mframe:PREV-SIBLING.
      IF NOT VALID-HANDLE(Mframe) THEN Mframe = Mwindow:LAST-CHILD.
      DO WHILE Mframe:HIDDEN:
         Mframe = Mframe:PREV-SIBLING.
         IF NOT VALID-HANDLE(Mframe) THEN Mframe = Mwindow:LAST-CHILD.
      END.
      Mfldgrp = Mframe:LAST-CHILD.
      Mwidget = Mfldgrp:LAST-CHILD.
   END.

   APPLY "ENTRY" TO Mwidget.
   RETURN NO-APPLY.
   END.
END.


/* --- Current dir must be in the PROPATH --- */
IF NOT CAN-DO(PROPATH,".") THEN ASSIGN
   PROPATH = ".," + PROPATH.


/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

SESSION:APPL-ALERT-BOXES = YES.

{&WINDOW-NAME}:ROW = 1.
{&WINDOW-NAME}:COLUMN = 1.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* These events will close the window and terminate the procedure.      */
/* (NOTE: this will override any user-defined triggers previously       */
/*  defined on the window.)                                             */
ON WINDOW-CLOSE OF {&WINDOW-NAME} DO:
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.
ON ENDKEY, END-ERROR OF {&WINDOW-NAME} ANYWHERE DO:
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  /* --- Set up the screens for TTY and GUI displays --- */
  IF SESSION:DISPLAY-TYPE = "TTY" THEN
     /* --- move navigation frame to the bottom of the screen --- */
     ASSIGN
        FRAME FRAME-Nav:ROW = 21.      
  ELSE
     {&WINDOW-NAME}:TITLE = Mwin-title.
  
  RUN enable_UI.
  IF SESSION:DISPLAY-TYPE = "TTY" THEN
     ASSIGN Btn_Help:SENSITIVE = NO
            Btn_Help:HIDDEN    = YES.
 
  RUN ScreenSetup.

  ASSIGN
     McurrentFrame = FRAME FRAME-Splash:HANDLE.

  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
    
END.

QUIT.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE assign_db_areas WINDOW-1 
PROCEDURE assign_db_areas :
/*------------------------------------------------------------------------------
  Purpose:     Allow storage area assignments for new tables and indices
               where applicable
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Marea-dbs AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mdb       AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mdf       AS CHARACTER NO-UNDO.
  DEFINE VARIABLE MTokens   AS CHARACTER NO-UNDO EXTENT 7.

  RUN get_new_version.
  IF RETURN-VALUE <> "" THEN RETURN.
      
  /* --- Connect database(s) --- */
  RUN disconnectAll.
  CONNECT -pf VALUE(FILL-IN-schema-pf) NO-ERROR.

  Marea-dbs = "".
           
  IF NOT ERROR-STATUS:ERROR
  THEN DO:
    INPUT STREAM Sin1 FROM VALUE("rtb_dbup~/" + MverDir + "~/schctrl").
    SCHCTRL-RECORD:
    REPEAT:
      IMPORT STREAM Sin1 MTokens.
      Mdb = MTokens[2].

      /* --- Ignore db versions less than 9 (no area support) --- */
      IF INTEGER(DBVERSION(Mdb)) < 9 OR
         INTEGER(DBVERSION(Mdb)) = ? THEN
         NEXT SCHCTRL-RECORD.
      Mdf = MTokens[5] + ".df".
      INPUT STREAM Sin2 FROM VALUE("rtb_dbup~/" + MVerDir + "~/" + Mdf).
      REPEAT:
        MTokens = "".
        IMPORT STREAM Sin2 MTokens.
        IF CAN-DO("ADD,CREATE",MTokens[1]) THEN
          IF CAN-DO("FILE,INDEX,TABLE",MTokens[2])
             AND NOT CAN-FIND(FIRST Tareas
                              WHERE Tareas.dbase = Mdb
                                AND Tareas.table-name = (IF CAN-DO("FILE,TABLE",Mtokens[2]) THEN
                                                           Mtokens[3]
                                                         ELSE
                                                           Mtokens[5])
                                AND Tareas.object    = MTokens[3]
                                AND Tareas.obj-type  = Mtokens[2]
                                AND Tareas.df-file   = Mdf)
          THEN DO:
            CREATE Tareas.
            ASSIGN Tareas.dbase     = Mdb
                   Tareas.table-name = (IF CAN-DO("FILE,TABLE",Mtokens[2]) THEN
                                          Mtokens[3]
                                        ELSE
                                          Mtokens[5])
                   Tareas.object    = MTokens[3]
                   Tareas.obj-type  = Mtokens[2]
                   Tareas.area-name = "Schema Area"
                   Tareas.df-file   = Mdf.
            IF NOT CAN-DO(Marea-dbs,Mdb) THEN
               Marea-dbs = Marea-dbs +
                           (IF Marea-dbs = "" THEN "" ELSE ",") +
                           Mdb.
         END.
      END.
      INPUT STREAM Sin2 CLOSE.
    END.
    INPUT STREAM Sin1 CLOSE.
  END. /* if not error... */
  ELSE DO:
    MESSAGE "Database(s) in" FILL-IN-schema-pf "could not be connected"
            VIEW-AS ALERT-BOX ERROR
            TITLE "DB Area Assignments".
    RETURN.
  END.

  IF Marea-dbs <> ""
  THEN
    RUN upddsa.w (INPUT Marea-dbs).
  ELSE
    MESSAGE "There are no updates for databases with storage areas."
            VIEW-AS ALERT-BOX INFORMATION
            TITLE "DB Area Assignments".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE checkFile WINDOW-1 
PROCEDURE checkFile :
/* -----------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
-------------------------------------------------------------*/
DEFINE INPUT PARAMETER  Pname           AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER Pfile-status    AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mline                   AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mi                      AS INTEGER NO-UNDO.
DEFINE VARIABLE Mb                      AS INTEGER NO-UNDO.
FILE-INFO:FILE-NAME = Pname.

IF FILE-INFO:FULL-PATHNAME = ? THEN
   DO:
   Pfile-status = "".
   RETURN.
   END.

/* File exists so check if it Empty, Binary or Text */

INPUT FROM VALUE(FILE-INFO:FULL-PATHNAME) BINARY NO-CONVERT.
IMPORT Mline.
   
IF LENGTH(Mline) = 0 THEN 
   DO:
   Pfile-status = "E".
   RETURN.
   END.

/* The file has data so check if it is Binary or Text */
DO Mi = 1 TO MIN(LENGTH(Mline),10):
   Mb = ASC(SUBSTRING(Mline,Mi,1)).
   IF (Mb > 31 AND Mb < 127) OR Mb = 10 OR Mb = 8 OR Mb = 12 THEN NEXT.
   Pfile-status = "B".
   RETURN.
END.   

Pfile-status = "T".
RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CompileCompctrl WINDOW-1 
PROCEDURE CompileCompctrl :
/* -----------------------------------------------------------
  Purpose:    Compile required release source.
  Parameters:
  Notes:      Read the rtb_inst/compctrl file and compile all programs
              that have a compile status of "M" (modified).
-------------------------------------------------------------*/
DEFINE INPUT PARAMETER Pcompile-type AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Mmsg          AS HANDLE NO-UNDO.

DEFINE VARIABLE Mfilepos        AS INTEGER            NO-UNDO.
DEFINE VARIABLE Mlastpos        AS INTEGER            NO-UNDO.
DEFINE VARIABLE Merror-number   AS INTEGER            NO-UNDO.
DEFINE VARIABLE Mobjcopy-src    AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mpath           AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mrcode          AS CHARACTER          NO-UNDO.
DEFINE VARIABLE MrcodeTarget    AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mrcodebase      AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Msrcrfile       AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mdstrfile       AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mcurdir         AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Merror          AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mfailed-compile AS LOGICAL INITIAL NO NO-UNDO.


/* --- Create a compile log file. --- */
OUTPUT STREAM Sout TO rtb_ilog~/compile.log NO-ECHO.
PUT STREAM Sout UNFORMATTED "Starting compile..." SKIP(1).

IF SEARCH("rtb_idat~/compath") <> ? THEN
   OS-COPY VALUE("rtb_idat~/compath") VALUE("rtb_inst~/compath").


IF SEARCH("rtb_inst~/compath") <> ? THEN DO:
   INPUT STREAM Sin1 FROM rtb_inst~/compath NO-ECHO.
   IMPORT STREAM Sin1 Mpath.
   INPUT STREAM Sin1 CLOSE.
   ASSIGN
      PROPATH = Mpath + "," + PROPATH.
END.  /* if search("rtb_inst ... */


/* --- Add "<DLC>/src" to PROPATH for character so our adeedit/proedit can
       find its included file {adeedit/_proedit.p).
       This is specific to Roundtable (Mroundtable = YES). --- */
IF SESSION:DISPLAY-TYPE = "TTY" AND Mroundtable THEN
   ASSIGN PROPATH = Mdlc_path + "/src," + PROPATH.
   
IF FILL-IN-Rcode <> "" THEN
   ASSIGN
       MrcodeTarget = REPLACE(FILL-IN-Rcode,"~\","~/") + "~/".


/* --- Connect database to be used in compile. --- */
CONNECT -pf VALUE(FILL-IN-compile-pf) NO-ERROR.
IF Mdb_lname = "rtb":U THEN CREATE ALIAS "prepo" FOR DATABASE VALUE(Mdb_lname).
IF ERROR-STATUS:ERROR THEN DO:
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + "Database could not be connected." +
                   CHR(10)).
   PUT STREAM Sout UNFORMATTED "Database could not be connected." SKIP.
   DO Merror-number = 1 TO ERROR-STATUS:NUM-MESSAGES:
      ASSIGN
         Merror = ERROR-STATUS:GET-MESSAGE(Merror-number).
      Mreturn-value = Mmsg:INSERT-STRING(Merror + CHR(10)).
      PUT STREAM Sout UNFORMATTED Merror SKIP. 
   END.  /* do merror-number ... */
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + 
                   "Errors above occurred while connecting to the " +
                   "database.  Modify parameters in " + FILL-IN-compile-pf +
                   "." + CHR(10)).
   OUTPUT STREAM Sout CLOSE.
   RETURN "Database not connected".
END.  /* if error-status:error */
   

IF SEARCH("rtb_inst/compobj.p") = ? THEN DO:
  ASSIGN
    Mreturn-value = Mmsg:INSERT-STRING("Compile of deployment " +
                    "procedures failed.  The update procedure was " +
                    "unable to locate ~"rtb_inst/compobj.p~"." +
                    CHR(10)).
  OUTPUT STREAM Sout CLOSE.
  RETURN "Failed".
END.  /* if search("rtb_inst/compobj.p") = ? then */


ASSIGN
  Mcancel  = NO
  Mfilepos = 0.

/* --- Loop through the source program names in the rtb_inst/compctrl file,
       and compile each program that requires compiling. --- */  
COMPILE-BLOCK:
DO:

   Mreturn-value = Mmsg:INSERT-STRING("Compiling files identified in " +
                   "rtb_inst~/compctrl..." + CHR(10)).
   PUT STREAM Sout UNFORMATTED "Compiling files identified in " +
                   "rtb_inst~/compctrl to " + 
                   (IF Mrcodetarget = "" THEN
                       SESSION:TEMP-DIRECTORY 
                    ELSE
                       Mrcodetarget) +
                   "..." SKIP.

   REPEAT:
      PROCESS EVENTS.

      /* --- Check if the user has cancelled the compile. --- */
      IF Mcancel THEN DO:
         Mreturn-value = Mmsg:INSERT-STRING(CHR(10) +
                         "Compiles Interrupted." + CHR(10)).
         PUT STREAM Sout UNFORMATTED SKIP(1) "Compiles interrupted by user." SKIP.
         /* --- Disconnect all databases. --- */
         RUN disconnectAll.
         OUTPUT STREAM SOut CLOSE.
         RETURN "Canceled".
      END.  /* if mcancel */
      
      /* --- Get next compile control record. --- */
      INPUT STREAM Sin1 FROM rtb_inst~/compctrl NO-ECHO.
      SEEK STREAM Sin1 TO Mfilepos.
      CREATE Wcomp.
      IMPORT STREAM Sin1 Wcomp.
      ASSIGN
         Mlastpos = Mfilepos
         Mfilepos = SEEK(Sin1).
      INPUT STREAM Sin1 CLOSE.
   
      IF Wcomp.object = "" OR Wcomp.object = ? THEN NEXT.
      
      /* --- Only compile objects with a compile status of modified. ("M") --- */
      IF Wcomp.comp-status <> "M" THEN NEXT.

      /* --- Inform user of the program being compiled. --- */
      Mreturn-value = Mmsg:INSERT-STRING("Compiling " + Wcomp.object + 
                      "..." + CHR(10)).
      PUT STREAM Sout UNFORMATTED "Compiling " + Wcomp.object + " " +
                                  Wcomp.comp-params + "..." SKIP.

      /* --- Compile object. --- */
      RUN rtb_inst/compobj.p (INPUT TB-IgnoreWarnings:CHECKED IN FRAME frame-ObjCompile,
                              OUTPUT Merror)
         Wcomp.object "SAVE NO-ERROR " + Wcomp.comp-params.

      IF Merror <> "" THEN DO:
        ASSIGN
           Mreturn-value   = Mmsg:INSERT-STRING("  Compile Failed - " + 
                             Merror + CHR(10))
           Mfailed-compile = YES.
        PUT STREAM Sout UNFORMATTED "  Compile Failed - " + Merror SKIP.
      END.  /* if merror <> "" */
      ELSE IF Wcomp.save-into <> "" OR MrcodeTarget <> "" THEN DO:
         IF 0 <> R-INDEX(Wcomp.object,".") THEN
            ASSIGN
               Mrcode = SUBSTRING(Wcomp.object,1,R-INDEX(Wcomp.object,".") - 1) + ".r".
         ELSE
            ASSIGN
               Mrcode = Wcomp.object + ".r".

         ASSIGN
            Mrcode              = REPLACE(Mrcode,"~\","~/")
            Mrcodebase          = SUBSTRING(Mrcode,R-INDEX(Mrcode,"~/") + 1)
            Wcomp.save-into     = REPLACE(Wcomp.save-into,"~\","~/")
            FILE-INFO:FILE-NAME = Mrcode
            Msrcrfile           = REPLACE(FILE-INFO:FULL-PATHNAME,"~\","~/").

         /* --- Copy to absolute target directory. --- */
         IF MrcodeTarget <> "" THEN DO: 
            ASSIGN
               Mdstrfile = MrcodeTarget + 
                           (IF Wcomp.save-into <> "" THEN
                               REPLACE(Wcomp.save-into,"~\","~/") + "~/" + Mrcodebase
                            ELSE
                               Mrcode).

            IF Mdstrfile <> Msrcrfile THEN DO:
               /* --- Create directory if necessary. --- */
               RUN makeDirectory(Mdstrfile,OUTPUT Merror).
               IF Merror <> "" THEN DO:
                  Mreturn-value = Mmsg:INSERT-STRING(Merror + CHR(10)).
                  RUN disconnectAll.
                  PUT STREAM Sout UNFORMATTED Merror SKIP.
                  OUTPUT STREAM SOut CLOSE.
                  RETURN "Failed".
               END.  /* if merror <> "" */
               OS-COPY VALUE(Msrcrfile) VALUE(Mdstrfile).
               OS-DELETE VALUE(Msrcrfile).
            END.  /* if mdstrfile <> msrcrfile */
         END.  /* if mrcodetarget <> "" */
         ELSE DO:
            /* --- Copy relative to MrcodeTarget directory. --- */
            ASSIGN
               Mdstrfile = REPLACE(Wcomp.save-into,"~\","~/") + "~/" + Mrcodebase.
            IF Mdstrfile <> Mrcode THEN DO:
               /* --- Create directory if necessary. --- */
               RUN makeDirectory(Mdstrfile,OUTPUT Merror).
               IF Merror <> "" THEN DO:
                  Mreturn-value = Mmsg:INSERT-STRING(Merror + CHR(10)).
                  RUN disconnectAll.
                  PUT STREAM Sout UNFORMATTED Merror SKIP.
                  OUTPUT STREAM SOut CLOSE.
                  RETURN "Failed".
               END.  /* if merror <> "" */
               OS-COPY VALUE(Mrcode) VALUE(Mdstrfile).
               OS-DELETE VALUE(Mrcode).        
            END.  /* if mdstrfile <> mrcode */
         END.  /* else do */

      END.  /* else if wcomp.save-into <> "" or ... */
      
      OUTPUT STREAM Sout1 TO rtb_inst~/compctrl NO-ECHO APPEND.
      SEEK STREAM Sout1 TO Mlastpos + LENGTH(Wcomp.object) + 6.
      PUT STREAM Sout1 UNFORMATTED "C".
      OUTPUT STREAM Sout1 CLOSE.
      DELETE Wcomp.

   END.  /* repeat */


   Mreturn-value = Mmsg:INSERT-STRING("Compiles complete." + CHR(10)).
   PUT STREAM Sout UNFORMATTED "Compiles complete." SKIP.


   /* --- Copy bitmaps and other special files identified in
          rtb_inst/objcopy... --- */
   IF MrcodeTarget <> "" THEN DO:
      Mobjcopy-src = IF Pcompile-type = "Full" THEN
                       "rtb_inst~/objcopy.ful"
                     ELSE
                       "rtb_inst~/objcopy.sel".

      IF SEARCH(Mobjcopy-src) <> ? THEN DO:

         Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + "Copying files "
                         + "identified in " + Mobjcopy-src
                         + "..." + CHR(10)).
         PUT STREAM Sout UNFORMATTED SKIP(1) "Copying files "
                         + "identified in " + Mobjcopy-src
                         + "..." SKIP.
                         
         INPUT FROM VALUE(Mobjcopy-src).

         REPEAT:
            ASSIGN
               Msrcrfile = "".
            IMPORT Msrcrfile.
            IF Msrcrfile = "" THEN
               NEXT.
            ASSIGN
               Msrcrfile = REPLACE(Msrcrfile,"~\","~/")
               Mdstrfile = MrcodeTarget + Msrcrfile.
            IF Mdstrfile <> Msrcrfile THEN DO:
               IF Msrcrfile MATCHES "*~/" THEN DO:
                  /* --- Copy entire directory. --- */
                  RUN xcopy(Msrcrfile,Mdstrfile,"").
               END.  /* if msrcsfile matches ... */
               ELSE DO:
                  Mreturn-value = Mmsg:INSERT-STRING(
                                  "Copying " + Msrcrfile + " to " +
                                  Mdstrfile + "..." + CHR(10)).
                  PUT STREAM Sout UNFORMATTED "Copying " + Msrcrfile +
                                  " to " + Mdstrfile + "..." SKIP.
                  RUN makeDirectory(Mdstrfile,OUTPUT Merror).
                  /* If UNIX, use cp.
                   * OS-COMMAND does not preserve file permissions.
                   * This is important for things like shell scripts.
                   */
                  IF OPSYS = "UNIX":U THEN
                     OS-COMMAND SILENT VALUE
                        ("cp " + Msrcrfile + " " + Mdstrfile).
                  ELSE
                     OS-COPY VALUE(Msrcrfile) VALUE(Mdstrfile).
               END.  /* else do */
            END.  /* if mdstrfile <> msrcfile */
         END.   /* repeat */

         INPUT CLOSE.

         Mreturn-value = Mmsg:INSERT-STRING("Copies complete." + CHR(10)).
         PUT STREAM Sout UNFORMATTED "Copies complete." SKIP.
         
      END.  /* if search(mobjcopy-src ... */

   END.  /* if mrcodetarget <> "" */

END.  /* COMPILE-BLOCK */


RUN disconnectAll. /* disconnect all databases */

/* --- Close compile log file. --- */
IF Mfailed-compile THEN
   PUT STREAM Sout UNFORMATTED SKIP(1) "Compile process failed." SKIP.
ELSE
   PUT STREAM Sout UNFORMATTED SKIP(1) "Compile process complete." SKIP.
OUTPUT STREAM SOut CLOSE.

/* --- Set return-value. --- */
IF Mfailed-compile THEN
   RETURN "failed compile".
ELSE
   RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CompileSource WINDOW-1 
PROCEDURE CompileSource :
/*------------------------------------------------------------------------------
  Purpose:    Compile the source included with the release. 
  Parameters: Pcompile-type - Type of compile to be performed.  Either
              "full" or "incremental" (selective).
  Notes:      This utility reads the rtb_inst/compctrl file to determine
              how to compile objects in the Workspace.  The compctrl file
              is a text file with records in EXPORT format.
------------------------------------------------------------------------------*/

DEFINE INPUT PARAMETER Pcompile-type AS CHARACTER NO-UNDO.

DEFINE VARIABLE Mmsg-Handle    AS HANDLE             NO-UNDO.
DEFINE VARIABLE Mcompile-error AS LOGICAL INITIAL NO NO-UNDO.
DEFINE VARIABLE Mobject        AS CHARACTER          NO-UNDO.

DEFINE BUTTON BT-Compile-Done   LABEL "OK" AUTO-GO SIZE 12 BY 1. 
DEFINE BUTTON BT-Compile-Cancel LABEL "Cancel"     SIZE 12 BY 1
   TRIGGERS:
      ON CHOOSE DO:
         ASSIGN
            Mcancel = YES.              
         RETURN NO-APPLY.
      END.  /* on choose */
   END TRIGGERS.      

DEFINE FRAME Compile-Status
   Mmsg
      NO-LABEL
      AT COLUMN 3 ROW 1.5
   SKIP
   BT-Compile-Done
      AT COLUMN 64 ROW 12
   BT-Compile-Cancel
      AT COLUMN 50 ROW 12
WITH
   SIZE 77 BY 14
   THREE-D
   FONT 4
   SIDE-LABELS
   CANCEL-BUTTON BT-Compile-Cancel
   TITLE "Compile of {&APPLICATION-NAME} Procedures"
   VIEW-AS DIALOG-BOX.


ON CHOOSE OF BT-Compile-Cancel IN FRAME Compile-Status DO:
   ASSIGN
      Mcancel = YES.
  RETURN NO-APPLY.
END.


ASSIGN
   Mmsg = ""
   FRAME Compile-Status:TITLE = Pcompile-type + " Compile of {&APPLICATION-NAME} Procedures".
   
DISPLAY
   Mmsg
   BT-Compile-Done
   BT-Compile-Cancel
WITH FRAME Compile-Status.

ASSIGN
   Mmsg-handle = Mmsg:HANDLE IN FRAME Compile-Status.

ENABLE ALL WITH FRAME Compile-Status.

APPLY "ENTRY" TO Mmsg IN FRAME Compile-Status.

ASSIGN
   Mmsg:READ-ONLY            = YES
   BT-Compile-Done:SENSITIVE = NO.
   
Mreturn-value = Mmsg:INSERT-STRING("Starting " + LC(Pcompile-type) +
                " compile.   Please wait..." + CHR(10) + CHR(10)).


/* --- Compile the programs included with the release. --- */
IF Pcompile-type = "Full" THEN
  DO:
    /* --- Build a new compctrl file. --- */
    RUN UpdateCompctrl (INPUT "Full",
                        INPUT Mmsg-handle).
    RUN CompileCompctrl (INPUT "Full",
                         INPUT Mmsg-handle).
  END.
ELSE
  DO:
    /* --- Build a new compctrl file. --- */
    RUN UpdateCompctrl (INPUT "Selective",
                        INPUT Mmsg-handle).
    RUN CompileCompctrl (INPUT "Selective",
                         INPUT Mmsg-handle).
  END.

IF RETURN-VALUE <> "" THEN
   ASSIGN
      Mreturn-value  = Mmsg:INSERT-STRING(CHR(10) +
                       "Compile failed.  Review log above.  Press OK to continue." +
                       CHR(10))
      Mcompile-error = YES.
ELSE
   ASSIGN
      Mreturn-value  = Mmsg:INSERT-STRING(CHR(10) +
                       "Compile complete.  Press OK to continue." +
                       CHR(10))
      Mcompile-error = NO.


ASSIGN
   BT-Compile-Cancel:SENSITIVE = NO
   BT-Compile-Done:SENSITIVE   = YES.

WAIT-FOR GO OF FRAME Compile-Status.

HIDE FRAME Compile-Status.

/* --- Ensure a correct return-value is returned. --- */
IF Mcompile-error THEN
   RETURN "Error".
ELSE
   RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE compileUpdateProcs WINDOW-1 
PROCEDURE compileUpdateProcs :
/* -----------------------------------------------------------
  Purpose: Compile programs used during the schema update.
  Notes:       
-------------------------------------------------------------*/

DEFINE INPUT PARAMETER Pschema-pf AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Pmsg       AS HANDLE    NO-UNDO.

DEFINE VARIABLE Mfile-status  AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mline         AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mcmd          AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfilepos      AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mseek         AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mtime-out     AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mlock-removed AS LOGICAL   NO-UNDO.



Mreturn-value = Pmsg:INSERT-STRING("Compiling schema update procedures ").

/* --- Delete any old log files. --- */
OS-DELETE VALUE("rtb_ilog~/schcomp.err").
OS-DELETE VALUE("rtb_ilog~/schcomp.srt").
OS-DELETE VALUE("rtb_ilog~/schcomp.log").

/* If the update procedures are encrypted then compile them with a 
   progress client launched with the -rx flag. Because the -rx flag
   controls which client copy of PROGRESS is loaded we must run it
   from the OS level. */

/* The Mfile-status returned below indicates if the schcomp.p is encrypted */
RUN checkFile(Mrtb_instPath + "schcomp.p",OUTPUT Mfile-status).

/* To keep the DOS path as short as possible - create a special
   schcomp.pf file to contain the compile options */
OS-COPY VALUE(Pschema-pf) VALUE(Mrtb_instPath + "schcomp.pf").
OUTPUT TO VALUE(Mrtb_instPath + "schcomp.pf") APPEND UNBUFFERED.
PUT UNFORMATTED " -b -p " + fnOsQuote(Mrtb_instPath + "schcomp.p").
OUTPUT CLOSE.   
IF SESSION:DISPLAY-TYPE = "TTY" THEN DO:
   IF OPSYS = "UNIX" THEN
      Mcmd = fnOsQuote(Mdlc_path + "~/bin~/pro") + " -pf "
        + fnOsQuote(Mrtb_instPath + "schcomp.pf").
   ELSE
      Mcmd = fnOsQuote(Mdlc_path + "~\bin~\_progres") + " -pf " 
        + fnOsQuote(Mrtb_instPath + "schcomp.pf").
END. /* tty */
ELSE
   Mcmd = fnOsQuote(Mdlc_path + Mprowin) + " -pf "
     + fnOsQuote(Mrtb_instPath + "schcomp.pf").

IF Mfile-status = "B" THEN
   /* --- Encrypted. --- */
   ASSIGN
      Mreturn-value = Pmsg:INSERT-STRING("with encryption flag..." +
                      CHR(10))
      Mcmd          = Mcmd + " -rx".
ELSE IF Mfile-status = "T" THEN
   /* --- Not encrypted. --- */
   ASSIGN
      Mreturn-value = Pmsg:INSERT-STRING("without encryption flag..." +
                      CHR(10)).
ELSE DO:
   /* --- Schcomp file not found. --- */
   ASSIGN
      Mreturn-value  = Pmsg:INSERT-STRING("Compile of schema update " +
                       "procedures failed as schcomp.p file was not found." +
                       CHR(10)).
   RETURN "Failed".
END.  /* else do */


/* --- Create lock file that will be removed by the compile process. --- */
OUTPUT TO rtb_idat~/strtlock UNBUFFERED NO-ECHO.
OUTPUT CLOSE.


/* --- Launch the compile routine. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
DO:
   IF OPSYS = "UNIX" THEN
      OS-COMMAND NO-WAIT VALUE(Mcmd) > rtb_ilog/schcomp.srt.
   ELSE
      OS-COMMAND SILENT VALUE(Mcmd) .
END.
ELSE DO:
   OUTPUT TO rtb_ilog/schcomp.srt NO-ECHO.
   PUT UNFORMATTED "Executing: " + Mcmd.
   OUTPUT CLOSE.
   RUN WinExec (INPUT  Mcmd,
                INPUT  0,
                OUTPUT MdllError).
END.  /* else do */


/* --- Wait for compile procedure to delete strtlock. --- */
ASSIGN
  Mtime-out = 0.
DO WHILE SEARCH("rtb_idat~/strtlock") <> ?:
   PAUSE 1 NO-MESSAGE.
   ASSIGN
     Mtime-out = Mtime-out + 1.
   IF Mtime-out > 30 THEN
     LEAVE.
END.  /* do while search ... */

ASSIGN
  Mfilepos = 0.
  
/* --- Wait for compile procedure to delete runlock. --- */
ASSIGN
  Mlock-removed = NO.
DO WHILE NOT Mlock-removed:
   /* --- Report progress to user. --- */
   IF SEARCH("rtb_idat~/runlock") = ? THEN
      ASSIGN
         Mlock-removed = YES.
   PAUSE 1 NO-MESSAGE.
   IF SEARCH("rtb_ilog~/schcomp.log") <> ? THEN DO:
      INPUT STREAM Sin1 FROM "rtb_ilog~/schcomp.log" NO-ECHO.
      SEEK STREAM Sin1 TO END.
      ASSIGN
         Mseek = SEEK(Sin1).
      IF Mfilepos < Mseek THEN DO:
         SEEK STREAM Sin1 TO Mfilepos.
         REPEAT:
            IMPORT STREAM Sin1 UNFORMATTED Mline.
            ASSIGN
               Mreturn-value = Pmsg:INSERT-STRING(Mline + CHR(10)).
         END.  /* repeat */
         ASSIGN
            Mfilepos = Mseek.
      END.  /* if mfilepos < seek(input) */
      INPUT CLOSE.
   END.  /* if search ... */
END.  /* do while search ... */


/* --- Check schcomp.err file. --- */
IF SEARCH("rtb_ilog~/schcomp.err") <> ? THEN DO:
   INPUT FROM VALUE("rtb_ilog~/schcomp.err") UNBUFFERED NO-ECHO.
   REPEAT:
      IMPORT UNFORMATTED Mline.
      IF SUBSTRING(Mline,1,2) = "~*~*" THEN DO:
         ASSIGN
            Mreturn-value = Pmsg:INSERT-STRING("Compile of schema update " +
                            "procedures failed.  Check 'rtb_ilog~/schcomp.err' " +
                            "error file." +
                            CHR(10)).
         RETURN "Failed".
      END.  /* if substring ... */
   END.  /* repeat */
   INPUT CLOSE.
END.  /* if file-info:full-path <> ? */
ELSE DO:
   ASSIGN
      Mreturn-value = Pmsg:INSERT-STRING("Compile of schema update " +
                      "procedures failed to run.  Check rtb_ilog/schcomp.srt " +
                      "error file and ensure your schema parameter file is " +
                      "correct." +
                      CHR(10)).
   RETURN "Failed".
END.    /* else do */

Mreturn-value = Pmsg:INSERT-STRING("Schema update procedures compiled successfully." +
                                   CHR(10)).
                                   
RETURN.                                   

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CreateLocalDatabase WINDOW-1 
PROCEDURE CreateLocalDatabase :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mi             AS INTEGER NO-UNDO.
  DEFINE VARIABLE Mfailed-create AS LOGICAL NO-UNDO.

ASSIGN
  FILE-INFO:FILE-NAME = FILL-IN-NewDBLoc.

/* --- Warning ---
 * If you specify a database name like 'sports.db', then this check
 * will find it in the DLC directory. Use a different physical db name.
 * --------------- */
IF FILE-INFO:FULL-PATHNAME <> ? THEN DO:
   MESSAGE
      "Database '" +
      FILL-IN-NewDBLoc +
      "' was not created as it already exists."
      VIEW-AS ALERT-BOX INFORMATION
      TITLE Malert-title.
   RETURN.
END.  /* if file-info:full-pathname <> ? */

/* --- Ensure an empty database exists in the <DLC> directory. --- */
IF SEARCH(Mdlc_path + "~/empty.db") = ? THEN DO:
   MESSAGE
      "Database '" +
      FILL-IN-NewDBLoc +
      "' could not be created as an 'empty.db' was not found in '" +
      Mdlc_path +
      "'."
      SKIP(1)
      "Create an empty database ('empty.db') in '" +
      FILL-IN-NewDBLoc +
      "' and try again."
      VIEW-AS ALERT-BOX ERROR
      TITLE Malert-title.
   RETURN "Error".
END.  /* if search(mdlc_path ... */

/*     
OS-COPY VALUE(Mdlc_path + "~/empty.db") VALUE(FILL-IN-NewDBLoc).
*/

CREATE DATABASE FILL-IN-NewDBLoc FROM "EMPTY" NO-ERROR.
IF ERROR-STATUS:ERROR THEN
  DO:
    DO Mi = 1 TO ERROR-STATUS:NUM-MESSAGES:
      MESSAGE ERROR-STATUS:GET-MESSAGE(Mi)
        VIEW-AS ALERT-BOX ERROR
        TITLE Malert-title.
    END.
    Mfailed-create = TRUE.
  END.

/* --- Ensure the new database exists. --- */
IF Mfailed-create 
   OR SEARCH(FILL-IN-NewDBLoc) = ? THEN DO:
   MESSAGE 
      "Database '" +
      FILL-IN-NewDBLoc +
      "' could not be created."
      SKIP(1)
      "Create an empty database ('empty.db') in '" +
      FILL-IN-NewDBLoc +
      "' and try again."
      VIEW-AS ALERT-BOX ERROR
      TITLE Malert-title.
   RETURN "Error".
END.  /* if search(fill-in-newdbloc) = ? */
ELSE
   MESSAGE
      "Database '" +
      FILL-IN-NewDBLoc +
      "' was successfully created."
      VIEW-AS ALERT-BOX INFORMATION
      TITLE Malert-title.

RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CreatePFEntry WINDOW-1 
PROCEDURE CreatePFEntry :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

DEFINE INPUT PARAMETER Peditor-handle AS HANDLE    NO-UNDO.
DEFINE INPUT PARAMETER Ppf-filename   AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Pcontext-num   AS INTEGER   NO-UNDO.

DEFINE VARIABLE Mdbname        AS CHARACTER                NO-UNDO.
DEFINE VARIABLE Mlgname        AS CHARACTER                NO-UNDO.
DEFINE VARIABLE Mservicename   AS CHARACTER                NO-UNDO.
DEFINE VARIABLE Mhostname      AS CHARACTER                NO-UNDO.
DEFINE VARIABLE Muser          AS CHARACTER FORMAT "X(32)" NO-UNDO.
DEFINE VARIABLE Mpassword      AS CHARACTER FORMAT "x(16)" NO-UNDO.
DEFINE VARIABLE Myes           AS LOGICAL                  NO-UNDO.
DEFINE VARIABLE Mi             AS INTEGER                  NO-UNDO.
DEFINE VARIABLE MnumDbsCreated AS INTEGER                  NO-UNDO.

DEFINE VARIABLE Mnetwork AS CHARACTER
   VIEW-AS COMBO-BOX
   LIST-ITEMS "","TCP","SPX","DECnet","NETBIOS","TLI","DDE","WIPC","SNA","LFP"
   NO-UNDO.
   
DEFINE VARIABLE Mnetversion AS CHARACTER
   VIEW-AS COMBO-BOX
   LIST-ITEMS "","12"
   NO-UNDO.

DEFINE BUTTON dbCancelButton LABEL "Cancel" AUTO-ENDKEY SIZE 12 BY 1.
DEFINE BUTTON dbOkButton     LABEL "OK"     AUTO-GO     SIZE 12 BY 1. 
DEFINE BUTTON dbHelpButton   LABEL "Help"               SIZE 12 BY 1
   TRIGGERS:
      ON CHOOSE DO:
         IF Pcontext-num <> 0 THEN
            SYSTEM-HELP Mhelp CONTEXT Pcontext-num.
         ELSE
            MESSAGE
               "No Help defined for File: {&FILE-NAME}"
               VIEW-AS ALERT-BOX INFORMATION
               TITLE Malert-title.
      END.  /* on choose */
   END TRIGGERS.
   
DEFINE FRAME local-DB-options-frame
   SKIP(1)
   Mdbname
      LABEL "Physical Name -db"
      VIEW-AS FILL-IN
      FORMAT "x(30)"
      COLON 21
   SKIP
   Mlgname
      LABEL "Logical Name -ld"
      VIEW-AS FILL-IN
      FORMAT "x(30)"
      COLON 21 
   SKIP
   Muser
      LABEL "User -U"
      COLON 21
   SKIP
   Mpassword
      LABEL "Password -P"
      COLON 21
   SKIP(1)
   dbOkButton AT 24
   dbCancelButton
   dbHelpButton
   "   "
   SKIP(1)
WITH
   THREE-D
   FONT 4
   SIDE-LABELS
   KEEP-TAB-ORDER
   OVERLAY 
   NO-UNDERLINE
   CANCEL-BUTTON dbCancelButton
   DEFAULT-BUTTON dbOkButton
   TITLE "Local Database Parameters"
   VIEW-AS DIALOG-BOX.

DEFINE FRAME remote-DB-options-frame
   SKIP(1)
   Mdbname
      LABEL "Physical Name -db"
      VIEW-AS FILL-IN
      FORMAT "x(30)"
      COLON 21
   Mlgname
      LABEL "Logical Name -ld"
      VIEW-AS FILL-IN
      FORMAT "x(30)"
      COLON 21 
   Mservicename
      LABEL "Service Name -S"
      VIEW-AS FILL-IN
      FORMAT "x(30)"
      COLON 21
   Mhostname
      LABEL "Host Name -H"
      VIEW-AS FILL-IN
      FORMAT "x(30)"
      COLON 21
   Mnetwork
      LABEL "Network Type -N"
      COLON 21
   Mnetversion
      LABEL "Network Version -Nv"
      COLON 21
   Muser
      LABEL "User -U"
      COLON 21
   Mpassword
      LABEL "Password -P"
      COLON 21
   SKIP(1)
   dbOkButton AT 24
   dbCancelButton
   dbHelpButton
   "   "
   SKIP(1)
WITH
   THREE-D
   FONT 4
   SIDE-LABELS
   KEEP-TAB-ORDER
   OVERLAY 
   NO-UNDERLINE
   CANCEL-BUTTON dbCancelButton
   DEFAULT-BUTTON dbOkButton
   TITLE "Remote Database Parameters"
   VIEW-AS DIALOG-BOX.


   IF Ppf-filename = "" THEN DO:
      MESSAGE
         "You must specify a parameter file before creating a new " +
         "database entry."
         VIEW-AS ALERT-BOX WARNING
         TITLE Malert-title.
      RETURN "Error".
   END.  /* if fill-in-compile-pf */

   RUN scanPfFile (INPUT  Peditor-handle,
                   OUTPUT MdbsInPf,
                   OUTPUT MdbsVer,
                   OUTPUT MdbCopies,
                   OUTPUT Mrxneeded).

   IF NUM-ENTRIES(MdbsInPf) > 0 THEN DO:
      MESSAGE
         "One or more pf entries exist."
         SKIP(1)
         "Create another pf entry?"
         VIEW-AS ALERT-BOX WARNING
         BUTTONS YES-NO
         TITLE Malert-title
         UPDATE Myes.
      IF Myes <> YES THEN
         RETURN "".
   END.  /* if num-entries(mdbsinpf) > 0 */

   MESSAGE
      "Creating a new pf entry."
      SKIP(1)
      "Is the new pf entry for a remote database?"
      VIEW-AS ALERT-BOX WARNING
      BUTTONS YES-NO-CANCEL 
      TITLE "Creating pf entry"
      UPDATE Mremote AS LOGICAL.
      
   IF Mremote = ? THEN
      RETURN.

   ASSIGN
      FILE-INFO:FILE-NAME = Ppf-filename.
      
   IF NUM-ENTRIES(MdbsInPf) > 0 THEN 
      ASSIGN
         Mlgname = ""
         Mdbname = "".
   ELSE
      ASSIGN
         Mlgname = Mdb_lname
         Mdbname = IF FILE-INFO:PATHNAME BEGINS ".~/" THEN
                      Mdb_pname
                   ELSE
                      SUBSTRING(FILE-INFO:PATHNAME,1,
                                R-INDEX(FILE-INFO:PATHNAME,"~/")) +
                      Mdb_pname.

   
   IF Mremote THEN DO:
               
      ENABLE
         dbOkButton
         dbCancelButton
         dbHelpButton
      WITH FRAME remote-DB-options-frame.

      ON CHOOSE OF dbCancelButton IN FRAME remote-DB-options-frame DO:
         APPLY "END-ERROR" TO FRAME remote-DB-options-frame.
      END.  /* on choose of dbCancelButton */
      
      DISPLAY 
         Mdbname
         Mlgname
         Mservicename
         Mhostname
         Mnetwork
         Mnetversion
         Muser
         Mpassword
      WITH FRAME remote-DB-options-frame.
   
      UPDATE
         Mdbname
         Mlgname WHEN NUM-ENTRIES(MdbsInPF) > 0
         Mservicename
         Mhostname
         Mnetwork
         Mnetversion
         Muser
         Mpassword
      WITH FRAME remote-DB-options-frame.

   END.  /* if mremote */
   ELSE DO:        
   
      ENABLE
         dbOkButton
         dbCancelButton
         dbHelpButton
      WITH FRAME local-DB-options-frame.
      
      ON CHOOSE OF dbCancelButton IN FRAME local-DB-options-frame DO:
         APPLY "END-ERROR" TO FRAME local-DB-options-frame.
      END.  /* on choose of dbCancelButton */
   
      DISPLAY
         Mdbname
         Mlgname
         Muser
         Mpassword
      WITH FRAME local-DB-options-frame.   
   
      UPDATE
         Mdbname
         Mlgname WHEN NUM-ENTRIES(MdbsInPF) > 0
         Muser
         Mpassword
      WITH FRAME local-DB-options-frame.
      
   END.  /* if mremote else do */
   
   ASSIGN
      Mreturn-value = Peditor-handle:MOVE-TO-EOF().
   
   /* --- TTY does not move the editor widget to a new line --- */
   IF SESSION:DISPLAY-TYPE = "TTY" THEN
      Mreturn-value = Peditor-handle:INSERT-STRING(CHR(10)).
      
   ASSIGN
      Mreturn-value = Peditor-handle:INSERT-STRING(" -db " + Mdbname + " -ld " +
                                          Mlgname +
                                          (IF Mremote THEN "" ELSE " -1") +
                                          CHR(10)).

   IF Muser <> "" THEN
      ASSIGN
         Mreturn-value = Peditor-handle:INSERT-STRING(" -U " + '"' + Muser + '"' +
                                             CHR(10)).
     
   IF Mpassword <> "" THEN
      ASSIGN
         Mreturn-value = Peditor-handle:INSERT-STRING(" -P " + '"' + Mpassword +
                                             '"' + CHR(10)).
  
   IF Mservicename <> "" THEN 
      ASSIGN
         Mreturn-value = Peditor-handle:INSERT-STRING(" -S " + Mservicename +
                                             "  #Service Name" + CHR(10)).
      
   IF Mhostname <> "" THEN 
      ASSIGN
         Mreturn-value = Peditor-handle:INSERT-STRING(" -H " + Mhostname +
                                             "   #Host Name" + CHR(10)).
      
   IF Mnetwork <> "" THEN 
      ASSIGN
         Mreturn-value = Peditor-handle:INSERT-STRING(" -N " + Mnetwork +
                                             "   #Network Type" + CHR(10)).

   IF Mnetversion <> "" THEN 
      ASSIGN
         Mreturn-value = Peditor-handle:INSERT-STRING(" -Nv " + Mnetversion +
                                             "   #Network Version" + CHR(10)).

   APPLY "LEAVE" TO Peditor-handle.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE create_rtbpf WINDOW-1 
PROCEDURE create_rtbpf :
/*------------------------------------------------------------------------------
  Purpose:     Create an rtb.pf file if one does not exist.
  Parameters:  <none>
  Notes:       Contents of the new rtb.pf is based on the user created
               schema.pf.  The parameters are only modified if the user is
               connecting to a local database, and did not specify the 
               full path to the database (-db).  Otherwise, only the comments
               of the schema pf are modified.
------------------------------------------------------------------------------*/

  DEFINE VARIABLE Mpwd            AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mline           AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mx              AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mremote         AS LOGICAL   NO-UNDO.


  /* --- Find present working directory. --- */
  INPUT THROUGH pwd NO-ECHO.
    IMPORT Mpwd.
  INPUT CLOSE.
  IF LENGTH(Mpwd) < 0 THEN
    RETURN "Failed".


  /* --- Determine if a Host or Service name is defined in the user defined
         schema pf file. --- */
  ASSIGN
    Mremote = NO.
  INPUT FROM VALUE(FILL-IN-schema-pf).
  PARSE-BLK:
  REPEAT ON ENDKEY UNDO, LEAVE PARSE-BLK:
    ASSIGN
      Mline = "".
    IMPORT UNFORMATTED Mline NO-ERROR.
    IF ERROR-STATUS:ERROR THEN DO:
      RETURN "Failed".
    END.  /* if error-status:error */
    /* --- Decide if line contains a -H or -S without a comment (#). --- */
    IF (INDEX(Mline,"-S") > 0 AND INDEX(Mline,"-S") < INDEX(Mline,"#")) OR
       (INDEX(Mline,"-H") > 0 AND INDEX(Mline,"-H") < INDEX(Mline,"#")) THEN DO:
      ASSIGN
        Mremote = YES.
      LEAVE PARSE-BLK.
    END.  /* if index("-s"... */
  END.  /* PARSE-BLK */  


  /* --- Add header to new rtb.pf file. --- */
  OUTPUT TO "rtb.pf".
  IF Mremote THEN
    PUT UNFORMATTED "# rtb.pf - Roundtable start up parameter file (remote DB)."
                    SKIP.
  ELSE
    PUT UNFORMATTED "# rtb.pf - Roundtable start up parameter file." SKIP.


  /* --- Build rtb.pf file. --- */
  INPUT FROM VALUE(FILL-IN-schema-pf).
  PARSE-BLK:
  REPEAT ON ENDKEY UNDO, LEAVE PARSE-BLK:
    ASSIGN
      Mline = "".
    IMPORT UNFORMATTED Mline NO-ERROR.
    IF ERROR-STATUS:ERROR THEN DO:
      RETURN "Failed".
    END.  /* if error-status:error */
  
    /* --- Remove commented lines. --- */
    IF Mline BEGINS "#" THEN
      NEXT.
  
    /* --- If pf is for a remote database, build rtb.pf file the same as the 
           schema pf (except for commented lines). --- */
    IF Mremote THEN DO:
      PUT UNFORMATTED Mline SKIP.
      NEXT.
    END.  /* if mremote */
 
    /* --- If the line does not contain the -db parameter, then output the line
           as it is. --- */
    IF LOOKUP("-db",Mline," ") = 0 THEN DO:
      PUT UNFORMATTED Mline SKIP.
      NEXT.
    END.  /* if lookup("-db" ... */
    
    /* --- If we are here, the pf file is not for a remote database, and the 
           current line (from the schema pf) contains the "-db" parameter.
           We need to ensure the database argument is fully quantified. --- */
    DO Mx = 1 TO NUM-ENTRIES(Mline," "):
      IF ENTRY(Mx,Mline," ") = "-db" THEN DO:
        PUT UNFORMATTED ENTRY(Mx,Mline," ") + " ".
        ASSIGN
          Mx = Mx + 1.
        IF ENTRY(Mx,Mline," ") BEGINS "~\" OR
           ENTRY(Mx,Mline," ") BEGINS "~/" THEN
          PUT UNFORMATTED ENTRY(Mx,Mline," ") + " ".
        ELSE
          PUT UNFORMATTED Mpwd + "/" + ENTRY(Mx,Mline," ") + " ".
      END.  /* if entry(mx,mline,"") = "-db" */
      ELSE
        PUT UNFORMATTED ENTRY(Mx,Mline," ") + " ".
    END.  /* do mx = 1 ... */
    PUT UNFORMATTED SKIP.

  END.  /* PARSE-BLK */

  INPUT CLOSE.


  /* --- Close rtb.pf output file. --- */
  OUTPUT CLOSE.


  /* --- Clear return value. --- */  
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DeleteTempdata WINDOW-1 
PROCEDURE DeleteTempdata :
/* --------------------------------------------------------------------
  Purpose:     Delete any data files created by pre-update processing.
  Parameters:  
  Notes:       
-------------------------------------------------------------------- */
  DEFINE VARIABLE Mctrlfile  AS CHARACTER          NO-UNDO.
  DEFINE VARIABLE Mname      AS CHARACTER          NO-UNDO.
  DEFINE VARIABLE Mfullname  AS CHARACTER          NO-UNDO.
  DEFINE VARIABLE Mschctrl   AS CHARACTER EXTENT 6 NO-UNDO.
     /* --- Mschctrl[1] updstatus 
            Mschctrl[2] dbase    
            Mschctrl[3] filename
            Mschctrl[4] deact-idx
            Mschctrl[5] prog-code
            Mschctrl[6] dbdir     --- */
  DEFINE VARIABLE MisEmpty   AS LOGICAL            NO-UNDO.

  ASSIGN Mctrlfile = "rtb_idat/schctrl".
  
  /* --- Read through the rtb_idat/schctrl file and delete any
         corresponding data files --- */
  INPUT STREAM Sin1 FROM VALUE(Mctrlfile) NO-ECHO.
  REPEAT:
    Mschctrl = "".
    IMPORT STREAM Sin1 Mschctrl.
    IF Mschctrl[6] = "" THEN Mschctrl[6] = "rtb_idat/tempdata".
    IF SEARCH(Mschctrl[6] + "/" + Mschctrl[5] + ".d") <> ? THEN
      OS-DELETE VALUE(SEARCH(Mschctrl[6] + "/" + Mschctrl[5] + ".d")).
    /*--- Rmove empty directories ---*/
    IF SEARCH(Mschctrl[6]) <> ? THEN
      DO:
        INPUT FROM OS-DIR(Mschctrl[6]).
        MisEmpty = YES.
        REPEAT:
           IMPORT Mname Mfullname.
           IF Mname <> "." AND Mname <> ".." THEN MisEmpty = NO.
        END.  /* repeat */
        IF MisEmpty THEN OS-DELETE VALUE(Mschctrl[6]).
      END.
  END.
  INPUT STREAM Sin1 CLOSE.

RETURN.

END PROCEDURE. /* DeleteTempdata */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI WINDOW-1  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WINDOW-1)
  THEN DELETE WIDGET WINDOW-1.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disconnectAll WINDOW-1 
PROCEDURE disconnectAll :
/* -----------------------------------------------------------
  Purpose: disconnect all databases    
  Parameters:  <none>
  Notes:       
-------------------------------------------------------------*/
DO WHILE LDBNAME(1) <> ?:
  DISCONNECT VALUE(LDBNAME(1)).
END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI WINDOW-1  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY EDITOR-PFFILE 
      WITH FRAME FRAME-DBEditPF IN WINDOW WINDOW-1.
  ENABLE BUTTON-New-pfentry EDITOR-PFFILE 
      WITH FRAME FRAME-DBEditPF IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-DBEditPF}
  DISPLAY FILL-IN-schema-pf 
      WITH FRAME FRAME-DBGetPF IN WINDOW WINDOW-1.
  ENABLE FILL-IN-schema-pf BUTTON-Browse 
      WITH FRAME FRAME-DBGetPF IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-DBGetPF}
  DISPLAY FILL-IN-NewDBLoc 
      WITH FRAME FRAME-DBLocal IN WINDOW WINDOW-1.
  ENABLE FILL-IN-NewDBLoc BUTTON-Browse-2 
      WITH FRAME FRAME-DBLocal IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-DBLocal}
  DISPLAY FILL-IN-Wait 
      WITH FRAME FRAME-DBUpdate IN WINDOW WINDOW-1.
  ENABLE BT-DBAreas 
      WITH FRAME FRAME-DBUpdate IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-DBUpdate}
  {&OPEN-BROWSERS-IN-QUERY-FRAME-Finish}
  DISPLAY FILL-IN-dlc-path 
      WITH FRAME FRAME-Get-dlc-path IN WINDOW WINDOW-1.
  ENABLE FILL-IN-dlc-path 
      WITH FRAME FRAME-Get-dlc-path IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-Get-dlc-path}
  DISPLAY RADIO-SET-DBupdate 
      WITH FRAME FRAME-Intro IN WINDOW WINDOW-1.
  ENABLE RADIO-SET-DBupdate 
      WITH FRAME FRAME-Intro IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-Intro}
  DISPLAY RADIO-SET-CompileType TB-IgnoreWarnings 
      WITH FRAME FRAME-OBJCompile IN WINDOW WINDOW-1.
  ENABLE RADIO-SET-CompileType TB-IgnoreWarnings 
      WITH FRAME FRAME-OBJCompile IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-OBJCompile}
  DISPLAY EDITOR-OBJPFFILE 
      WITH FRAME FRAME-OBJEditPF IN WINDOW WINDOW-1.
  ENABLE BUTTON-New-pfentry-2 EDITOR-OBJPFFILE 
      WITH FRAME FRAME-OBJEditPF IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-OBJEditPF}
  DISPLAY FILL-IN-compile-pf 
      WITH FRAME FRAME-OBJGetPF IN WINDOW WINDOW-1.
  ENABLE FILL-IN-compile-pf BUTTON-Browse-3 
      WITH FRAME FRAME-OBJGetPF IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-OBJGetPF}
  DISPLAY FILL-IN-Rcode 
      WITH FRAME FRAME-OBJGetTarget IN WINDOW WINDOW-1.
  ENABLE FILL-IN-Rcode 
      WITH FRAME FRAME-OBJGetTarget IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-OBJGetTarget}
  VIEW FRAME FRAME-Splash IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-Splash}
  ENABLE Btn_Next Btn_Cancel Btn_Help 
      WITH FRAME FRAME-Nav IN WINDOW WINDOW-1.
  VIEW FRAME FRAME-Nav IN WINDOW WINDOW-1.
  {&OPEN-BROWSERS-IN-QUERY-FRAME-Nav}
  VIEW WINDOW-1.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE expandSchctrl WINDOW-1 
PROCEDURE expandSchctrl :
/* -----------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
-------------------------------------------------------------*/
/* Define Locals */
DEFINE VARIABLE Mi         AS INTEGER NO-UNDO.
DEFINE VARIABLE Mtoken     AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mdbcopy    AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mdbcopyrec AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mddbase    AS CHARACTER NO-UNDO.

DEFINE VARIABLE Mschctrl   AS CHARACTER EXTENT 6 NO-UNDO.
/* Mschctrl[1] = Updatestatus
   Mschctrl[2] = dbase name
   Mschctrl[3] = filename
   Mschctrl[4] = deact-index
   Mschctrl[5] = program code
   Mschctrl[6] = dbdir 
*/

/* Check if #dbcopy entries exist and if they do we then check
  if the schctrl file has been expanded to accomodate additional
   copies of a baseline database.  
   
   The process that expands the schctrl file will place a marker at the
   begining of the schctrl file.  This marker is the token "EXPANDED".
*/

RUN scanPfFile /* This process seeds the MdbCopies string */
    (EDITOR-PFFILE:HANDLE IN FRAME FRAME-DBEditPF,
    OUTPUT MdbsInPf,
    OUTPUT MdbsVer,
    OUTPUT MdbCopies,
    OUTPUT Mrxneeded).
     
IF MdbCopies = "" THEN RETURN.

/* Each #dbcopy entry may have three entries
#dbcopy=dbbase,dbcopy,dbdir
   dbbase   -- This is the name of the base database
   dbcopy   -- This is the name of the copy of the base database
   dbdir    -- This is the name of the directory into which .d files
               are placed when we do data transformations.
*/

/* Check if the schctrl file has already been expanded */
INPUT FROM VALUE("rtb_idat~/schctrl") NO-ECHO.
IMPORT Mtoken.
INPUT CLOSE.

IF Mtoken = "EXPANDED" THEN
   RETURN.
      
/* Expand the schctrl file */
INPUT FROM VALUE("rtb_idat~/schctrl") NO-ECHO.
OUTPUT TO VALUE("rtb_idat~/schctrl.tmp") NO-ECHO.
EXPORT "EXPANDED".

REPEAT: /* read existing schctrl file and create new schctrl.tmp file */
   Mschctrl = "".
   IMPORT Mschctrl. 
   
   EXPORT
      Mschctrl[1] 
      Mschctrl[2]
      Mschctrl[3]
      Mschctrl[4]
      Mschctrl[5]
      "rtb_idat~/tempdata".

   DO Mi = 1 TO NUM-ENTRIES(MdbCopies, CHR(10)):
      Mdbcopyrec = ENTRY(Mi, MdbCopies, CHR(10)).
      Mddbase = ENTRY(1, Mdbcopyrec, " ").
      Mdbcopy = ENTRY(2, Mdbcopyrec, " ").
         
      /* If the user wants to redirect where the data of the baseline
      database is placed, they can simply make an entry in the 
      #dbcopy= line where the dbase and dbcopy fields are the same. */

      /* The following conditional creates a new entry in the schctrl
         file for each database copy. */
      IF Mddbase = Mschctrl[2] THEN
         IF Mdbcopy <> Mschctrl[2] THEN
            EXPORT
               Mschctrl[1] 
               Mdbcopy
               Mschctrl[3]
               Mschctrl[4]
               Mschctrl[5]
               ENTRY(3, Mdbcopyrec, " ").
   END.

END. /* of REPEAT to read schctrl file .. */
INPUT CLOSE.
OUTPUT CLOSE.

OS-COPY VALUE("rtb_idat~/schctrl.tmp") VALUE("rtb_idat~/schctrl").
OS-DELETE VALUE("rtb_idat~/schctrl.tmp").
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_new_version WINDOW-1 
PROCEDURE get_new_version :
/*------------------------------------------------------------------------------
  Purpose:     Determine new version/release for schema update.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE MbaseName       AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mstr            AS CHARACTER NO-UNDO.
  DEFINE VARIABLE MverList        AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mi              AS INTEGER   NO-UNDO.

  IF FILL-IN-schema-pf = "" THEN DO:
     MESSAGE
        "You must specify a parameters file before creating a new " +
        "database entry."
        VIEW-AS ALERT-BOX WARNING
        TITLE Malert-title.
     RETURN "Error".
  END.  /* if fill-in-schema-pf = "" */

  RUN scanPfFile (INPUT  EDITOR-PFFILE:HANDLE IN FRAME FRAME-DBEditPF,
                  OUTPUT MdbsInPf,
                  OUTPUT MdbsVer,
                  OUTPUT MdbCopies,
                  OUTPUT Mrxneeded).

  IF NUM-ENTRIES(MdbsInPf) = 0 THEN DO:
     MESSAGE 
        "No database is specified in the parameters file.  You must specify the " +
        "database connection parameters before doing the schema update."
        VIEW-AS ALERT-BOX WARNING
        TITLE Malert-title.
     RETURN "Error".
  END.  /* if num-entires(mdbsinpf) = 0 */
  
  /* --- Get correct release from user and copy files into rtb_idat. --- */
  IF MdbsVer = "" THEN DO:
  
     MESSAGE
        "Can not find the '#release=' token in the schema file being processed." 
        SKIP(1) 
        "This token is usually created when you allow this install process " +
        "to create a parameters file for you. However, you can add the " +
        "#release= token to the parameters file if necessary. If the database " +
        "is new and has not yet been updated by the update schema routines, " +
        "create a line in the parameter file that reads:"
        SKIP
        "#release=EMPTY"
        SKIP
        "If the database schema has been updated, create a line in the " +
        "parameter file that reads:"
        SKIP
        "#release=VER"
        SKIP
        "where VER is the current release level of the database."
        VIEW-AS ALERT-BOX ERROR
        TITLE Malert-title.
     RETURN "Error".
  
  END.  /* if mdbsver = "" then */
  ELSE IF MdbsVer BEGINS "installing" THEN DO:
     
     /* Get update release */                                       
     MESSAGE 
        "The #release= token in the parameters file indicates that " +
        "the previous attempt at updating the schema of this installation " +
        "was interrupted before it completed.  The schema may be in an " +
        "unpredictable state.  Please restore this installation to a " +
        "known state and restart from there."
        VIEW-AS ALERT-BOX ERROR
        TITLE Malert-title.
     RETURN "Error".
  
  END.  /* if mdbsver begins "installing" then */
  ELSE IF MdbsVer BEGINS "failed" THEN DO:
  
     MESSAGE
        "The #release= token in the parameters file indicates that " +
        "the previous attempt at updating the schema of this " +
        "installation failed.  The schema may be in an unpredictable " +
        "state.  Please restore this installation to a known state and " +
        "restart from there."
        VIEW-AS ALERT-BOX ERROR
        TITLE Malert-title.
     RETURN "error".
  
  END.  /* if mdbsver begins "failed" then */
  ELSE DO:
  
     /* --- Ensure the rtb_dbup directory exists. --- */
     ASSIGN
        FILE-INFO:FILE-NAME = "rtb_dbup".
     IF FILE-INFO:FULL-PATHNAME = ? THEN DO:
        MESSAGE
           "The database update sub-directory (rtb_dbup) does not exist " +
           "within the install directory.  This sub-directory is required " +
           "to perform a schema update.  Validate the installation and " +
           "ensure this sub-directory exists before continuing."
           VIEW-AS ALERT-BOX ERROR
           TITLE Malert-title.
        RETURN "Error".
     END.  /* if num-entries(mverlist) = 0 then */
  
     /* --- Get available updates available by looking in the rtb_dbup dir --- */
     INPUT FROM OS-DIR("rtb_dbup").
     REPEAT:
        IMPORT MbaseName.
        IF MbaseName BEGINS "." THEN NEXT.
        ASSIGN
           MverList = MverList +
                      (IF MverList = "" THEN
                          ""
                       ELSE ",") +
                      MbaseName.
     END.  /* repeat */
     INPUT CLOSE.
        
     IF NUM-ENTRIES(MverList) = 0 THEN DO:
        MESSAGE
           "No database update directories were found in the rtb_dbup " +
           "directory.  This could mean that there are no schema " +
           "changes.  Database update will be skipped." 
           VIEW-AS ALERT-BOX WARNING
           TITLE Malert-title.
        RETURN "Skip".
     END.  /* if num-entries(mverlist) = 0 then */
  
     ASSIGN
        MverDir = ""
        MnewVer = "".
        
     IF MdbsVer = "EMPTY" THEN DO:
     
        /* --- Search for full schema update directory. --- */
        DO Mi = 1 TO NUM-ENTRIES(MverList):
           ASSIGN
              Mstr = TRIM(ENTRY(Mi, MverList)).
           IF LENGTH(Mstr) <> 4 THEN NEXT.
           IF Mstr > MverDir THEN 
              ASSIGN
                 MverDir = Mstr
                 MnewVer = Mstr.
        END.  /* do mi = 1 to num-entries(mverlist) */
  
        IF MverDir = "" THEN DO:
           MESSAGE 
              "Can not find full update release directory." 
              SKIP
              "There is no full update database directory in the " +
              "rtb_dbup directory.  This could mean that there is no " +
              "schema.  Database update will be skipped."
              VIEW-AS ALERT-BOX WARNING
              TITLE Malert-title.
           RETURN "Skip".
        END.  /* if mverdir = "" then */
           
     END.  /* if mdbsver = "empty" then */
     ELSE DO:
     
        /* --- Search for incremental schema update directory. --- */
  
        DO Mi = 1 TO NUM-ENTRIES(MverList):
           ASSIGN
              Mstr = TRIM(ENTRY(Mi, MverList)).
           IF LENGTH(Mstr) <> 8 OR SUBSTRING(Mstr,1,4) <> MdbsVer THEN NEXT.
           IF SUBSTRING(Mstr,5,4) > SUBSTRING(MverDir,5,4) THEN
              ASSIGN
                 MverDir = Mstr
                 MnewVer = SUBSTRING(MverDir,5,4).
        END.  /* do mi = 1 to num-entries(mverlist) */
        
        IF MverDir = "" THEN DO:
           MESSAGE
              "Can not find incremental update release directory." 
              SKIP
              "There is no incremental update release directory in the " +
              "rtb_dbup directory.  This could mean that there are no " +
              "schema changes.  Database update will be skipped."
              VIEW-AS ALERT-BOX WARNING
              TITLE Malert-title.
           RETURN "Skip".
        END.  /* if mverdir = "" then */
           
     END.  /* if mdbsver = "empty" else do */
  END.
  RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE makeDirectory WINDOW-1 
PROCEDURE makeDirectory :
/* -----------------------------------------------------------
  Purpose:     Create directory path as required
  Parameters:  Input  - Filepath as character
               Output - Error message as character
  Notes:       
-------------------------------------------------------------*/
DEFINE INPUT PARAMETER Pdirectory AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER Perror    AS CHARACTER NO-UNDO.

DEFINE VARIABLE Mrelative AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mi        AS INTEGER NO-UNDO.
DEFINE VARIABLE Mpos      AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mpath     AS CHARACTER NO-UNDO.

Pdirectory = REPLACE(Pdirectory,"~\","~/").

/* Strip last token from path as we expect Pdirectory to be a fully qualified
   path to a file */
Mpath = SUBSTRING(Pdirectory,1,MAX(0,R-INDEX(Pdirectory,"~/") - 1)).

IF Mpath = "" THEN RETURN.

ASSIGN FILE-INFO:FILE-NAME = Mpath.
                                     
/* --- check if Mpath already exists --- */
IF FILE-INFO:FILE-TYPE = ? THEN
  DO:
    /* --- Path does not already exist.
           If path starts with a drive or UNC share name, start building
           directories after the drive specification or UNC share name.
           Also, skip ahead one character to ignore the leading character
           in the path (after the drive specification or UNC share name
           if it exists).  We are looking for slashes to find directories
           that need to be created and a leading slash indicates a root
           directory which we cannot create in any case. --- */
    ASSIGN
      Mpos = IF SUBSTRING(Mpath,2,1) = ":" AND SUBSTRING(Mpath,3,1) = "/" THEN
               4
             ELSE IF SUBSTRING(Mpath,1,1) = "/" AND
                     SUBSTRING(Mpath,2,1) = "/" THEN
               INDEX(Mpath,"/",INDEX(Mpath,"/",3) + 1) + 1
             ELSE
               2.

    /* --- create each part of the path name --- */
    DO WHILE TRUE:

      /* --- find next occurance of "/" --- */
      ASSIGN Mpos = INDEX(Pdirectory,"/",Mpos).

      /* --- no more "/" exist in after mpos --- */
      IF Mpos = 0 THEN LEAVE.  

      ASSIGN
        Mpath               = SUBSTRING(Pdirectory,1,Mpos - 1)
        Mpos                = Mpos + 1
        FILE-INFO:FILE-NAME = Mpath.

      IF FILE-INFO:FILE-TYPE = ? THEN
        DO:
          /* --- part of path does not exist --- */
          OS-CREATE-DIR VALUE(Mpath).
          Merror-status = OS-ERROR.
          IF Merror-status <> 0 THEN
            DO:
              Perror = "Error! OS error #" + STRING(Merror-status) + " while creating directory".
              RETURN.
            END.
        END.  /* if file-info:file-type = ? */
      ELSE
        DO: 
          /* --- Ensure part is a directory --- */
          IF INDEX(FILE-INFO:FILE-TYPE,"D") <> 0 THEN NEXT.
          Perror = "Error! Bad directory name: " + Mpath.
          RETURN.
        END.  /* if file-info:file-type = ? else */
    END.  /* do while true */

    RETURN.

  END.  /* if file-info:file-type = ? */
ELSE
  /* --- Mpath exists, ensure it is a directory --- */ 
  IF INDEX(FILE-INFO:FILE-TYPE,"D") <> 0 THEN RETURN.

ASSIGN 
  Perror = "Cannot create directory: " + Mpath + CHR(10) +
           "Invalid path specification.".
RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rx_message WINDOW-1 
PROCEDURE rx_message :
/* --------------------------------------------------------------------
  Purpose:     Display a message that -rx parameter is required
  Parameters:  None.
  Notes:       
   -------------------------------------------------------------------- */
   
   MESSAGE
     SUBSTITUTE(
     "&1This version of PROGRESS compiles only encrypted programs.&2&2&3",
     (IF SESSION:DISPLAY-TYPE = "TTY" THEN CHR(10) ELSE ""),
     CHR(10),
     "Please add the '-rx' parameter to the parameter file entries.")
     VIEW-AS ALERT-BOX ERROR
     TITLE Malert-title.

   RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scanPfFile WINDOW-1 
PROCEDURE scanPfFile :
/* -----------------------------------------------------------
  Purpose: Scan the contents of a parameters file to determine
           the number of database entries exist, the current version
           of the database and the number of database copies specified.    
  Parameters:  see below
  Notes:       
-------------------------------------------------------------*/
DEFINE INPUT  PARAMETER PedHandle AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER PdbsInPf  AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER PdbsVer   AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER Pdbcopies AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER Prxneeded AS LOGICAL   NO-UNDO.

DEFINE VARIABLE Mi   AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mstr AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mrx  AS LOGICAL   NO-UNDO.

ASSIGN
   PdbsInPf  = ""
   PdbsVer   = ""
   Pdbcopies = "".

DO Mi = 1 TO PedHandle:NUM-LINES:
   Mstr = TRIM(ENTRY(Mi, PedHandle:SCREEN-VALUE, CHR(10))).

   IF NOT Mrx THEN
     Mrx = INDEX(Mstr,"-rx") > 0.

   IF Mstr BEGINS "-db" THEN 
      DO:
      Mstr = TRIM(ENTRY(2, Mstr, " ")).
      IF Mstr <> "" THEN 
         PdbsInPf = PdbsInPf + (IF PdbsInPf <> "" THEN "," + Mstr ELSE Mstr).
      END.
   ELSE
   IF Mstr BEGINS "#release=" THEN
      PdbsVer = CAPS(TRIM(SUBSTRING(Mstr,10))).
   ELSE
   IF Mstr BEGINS "#dbcopy=" THEN
      Pdbcopies = Pdbcopies + (IF Pdbcopies <> "" THEN CHR(10) ELSE "") 
                + SUBSTRING(Mstr,9).
END.

IF progress <> "Full" AND NOT Mrx THEN
  Prxneeded = TRUE.
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE schemaUpdate1 WINDOW-1 
PROCEDURE schemaUpdate1 :
/* -----------------------------------------------------------
  Purpose: Call the shcema update phase 1 process and trap all errors
  Notes:   The schupd.p process is run as a batch process so that
           this _dbinst.w procedure does not have to be compiled with any
           database connected. This improves the portability
           of the install process.
-------------------------------------------------------------*/

DEFINE INPUT    PARAMETER Pschema-pf AS CHARACTER NO-UNDO.
DEFINE INPUT    PARAMETER Pmsg       AS HANDLE NO-UNDO.

DEFINE VARIABLE Mcmd          AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mline         AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfilepos      AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mseek         AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mtime-out     AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mlock-removed AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Mschema-error AS LOGICAL   NO-UNDO.


Mreturn-value = Pmsg:INSERT-STRING(CHR(10) +
                "Performing pre-schema update processing and schema update..." +
                CHR(10)).  

/* --- Clear any old schupd.err file. --- */
FILE-INFO:FILE-NAME = "rtb_ilog~/schupd.err".
IF FILE-INFO:FULL-PATHNAME <> ? THEN
   OS-DELETE VALUE(FILE-INFO:FULL-PATHNAME).
   
/* Create special schupd.pf to minimize DOS path length */
OS-COPY VALUE(Pschema-pf) VALUE(Mrtb_instPath + "schupd.pf").
OUTPUT TO VALUE(Mrtb_instPath + "schupd.pf") APPEND UNBUFFERED.
PUT UNFORMATTED " -b -p " + fnOsQuote(Mrtb_instPath + "schupd.p").
OUTPUT CLOSE.

IF SESSION:DISPLAY-TYPE = "TTY" THEN DO:
   IF OPSYS = "UNIX" THEN
      Mcmd = fnOsQuote(Mdlc_path + "~/bin~/pro") + " -pf "
        + fnOsQuote(Mrtb_instPath + "schupd.pf").
   ELSE
      Mcmd = fnOsQuote(Mdlc_path + "~\bin~\_progres") + " -pf "
        + fnOsQuote(Mrtb_instPath + "schupd.pf").
END. /* tty */
ELSE
   Mcmd = fnOsQuote(Mdlc_path + Mprowin) + " -pf "
     + fnOsQuote(Mrtb_instPath + "schupd.pf").


/* --- Create lock file that will be removed by the schema update process. --- */
OUTPUT TO rtb_idat~/strtlock UNBUFFERED NO-ECHO.
OUTPUT CLOSE.


/* --- Launch the compile routine. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN DO:
   IF OPSYS = "UNIX" THEN
      OS-COMMAND NO-WAIT VALUE(Mcmd) > rtb_ilog/schupd.srt.
   ELSE
      OS-COMMAND SILENT  VALUE(Mcmd) .
END. /* if tty */
ELSE DO:
   OUTPUT TO rtb_ilog/schupd.srt NO-ECHO.
   PUT UNFORMATTED "Executing: " + Mcmd.
   OUTPUT CLOSE.
   RUN WinExec (INPUT  Mcmd,
                INPUT  0,
                OUTPUT MdllError).
END.  /* else do */


/* --- Wait for schema update procedure to delete strtlock. --- */
ASSIGN
  Mtime-out = 0.
DO WHILE SEARCH("rtb_idat~/strtlock") <> ?:
   PAUSE 1 NO-MESSAGE.
   ASSIGN
     Mtime-out = Mtime-out + 1.
   IF Mtime-out > 30 THEN
     LEAVE.
END.

/* --- Wait for schema update procedure to delete runlock. --- */
ASSIGN
  Mlock-removed = NO.
DO WHILE NOT Mlock-removed:
   /* --- Report progress to user. --- */
   IF SEARCH("rtb_idat~/runlock") = ? THEN
      ASSIGN
         Mlock-removed = YES.
   PAUSE 1 NO-MESSAGE.
   IF SEARCH("rtb_ilog~/schupd.log") <> ? THEN DO:
      INPUT STREAM Sin1 FROM "rtb_ilog~/schupd.log" NO-ECHO.
      SEEK STREAM Sin1 TO END.
      ASSIGN
         Mseek = SEEK(Sin1).
      IF Mfilepos < Mseek THEN DO:
         SEEK STREAM Sin1 TO Mfilepos.
         REPEAT:
            IMPORT STREAM Sin1 UNFORMATTED Mline.
            ASSIGN
               Mreturn-value = Pmsg:INSERT-STRING(Mline + CHR(10)).
         END.  /* repeat */
         ASSIGN
            Mfilepos = Mseek.
      END.  /* if mfilepos < seek(input) */
      INPUT CLOSE.
   END.  /* if search ... */
END.  /* do while search ... */


/* --- Check the schupd.err file. --- */
FILE-INFO:FILE-NAME = "rtb_ilog~/schupd.err".
IF FILE-INFO:FULL-PATHNAME <> ? THEN DO:
   INPUT FROM VALUE(FILE-INFO:FULL-PATHNAME) UNBUFFERED NO-ECHO.
   ASSIGN
      Mschema-error = NO.
   REPEAT:
      IMPORT UNFORMATTED Mline.
      ASSIGN
         Mreturn-value = Pmsg:INSERT-STRING(Mline + CHR(10))
         Mschema-error = YES.
   END.  /* repeat */
   IF Mschema-error THEN DO:
      ASSIGN
         Mreturn-value = Pmsg:INSERT-STRING(CHR(10) +
                         "Pre-schema update processing and schema update failed." +
                         CHR(10)).
      RETURN "Failed".           
   END.  /* if mschema-error */
END.  /* if file-info ... */
ELSE DO:
   ASSIGN
      Mreturn-value = Pmsg:INSERT-STRING("Pre-schema update processing " +
                      "and schema update failed as schupd.p did not execute." +
                      CHR(10)).
   RETURN "Failed".
END.  /* else do */


Mreturn-value = Pmsg:INSERT-STRING("Pre-schema update processing and schema " +
                                   "update complete." +
                                   CHR(10)).

RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE schemaUpdate2 WINDOW-1 
PROCEDURE schemaUpdate2 :
/* -----------------------------------------------------------
  Purpose: Run the schupdp2.p procedure in batch mode             
  Parameters:  see below
  Notes:   This procedure is run in batch mode so that this
           _dbinst.w procedure can be compiled without any
           database connected. This improves the portability
           of the install process.
-------------------------------------------------------------*/

DEFINE INPUT PARAMETER Pschema-pf AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Pmsg       AS HANDLE NO-UNDO.

DEFINE VARIABLE Mline         AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mcmd          AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfilepos      AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mseek         AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mtime-out     AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mlock-removed AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Mschema-error AS LOGICAL   NO-UNDO.


Mreturn-value = Pmsg:INSERT-STRING(CHR(10) +
                "Performing post-schema update processing..." +
                CHR(10)).  

/* --- Clear any old schupdp2.err file. --- */
FILE-INFO:FILE-NAME = "rtb_ilog~/schupdp2.err".
IF FILE-INFO:FULL-PATHNAME <> ? THEN
   OS-DELETE VALUE(FILE-INFO:FULL-PATHNAME).
   
/* --- Create special schupdp2.pf to minimize DOS path length --- */
OS-COPY VALUE(Pschema-pf) VALUE(Mrtb_instPath + "schupdp2.pf").
OUTPUT TO VALUE(Mrtb_instPath + "schupdp2.pf") APPEND UNBUFFERED.
PUT UNFORMATTED " -b -p " + fnOsQuote(Mrtb_instPath + "schupdp2.p").
OUTPUT CLOSE.

IF SESSION:DISPLAY-TYPE = "TTY" THEN DO:
   IF OPSYS = "UNIX" THEN 
      Mcmd = fnOsQuote(Mdlc_path + "~/bin~/pro") + " -pf "
         + fnOsQuote(Mrtb_instPath + "schupdp2.pf").

   ELSE
      Mcmd = fnOsQuote(Mdlc_path + "~\bin~\_progres") + " -pf " 
        + fnOsQuote(Mrtb_instPath + "schupdp2.pf").
END. /* tty */
ELSE 
   Mcmd = fnOsQuote(Mdlc_path + Mprowin) + " -pf " 
     + fnOsQuote(Mrtb_instPath + "schupdp2.pf").


/* --- Create lock file that will be removed by the schema update process. --- */
OUTPUT TO rtb_idat~/strtlock UNBUFFERED NO-ECHO.
OUTPUT CLOSE.


/* --- Launch the compile routine. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN DO:
   PAUSE 5 NO-MESSAGE.
   IF OPSYS = "UNIX" THEN
      OS-COMMAND NO-WAIT VALUE(Mcmd) > rtb_ilog/schupdp2.srt.
   ELSE
      OS-COMMAND SILENT VALUE(Mcmd) .
END. /* tty */
ELSE DO:
   OUTPUT TO rtb_ilog/schupdp2.srt NO-ECHO.
   PUT UNFORMATTED "Executing: " + Mcmd.
   OUTPUT CLOSE.
   PAUSE 5 NO-MESSAGE.
   RUN WinExec (INPUT  Mcmd,
                INPUT  0,
                OUTPUT MdllError).
END.  /* else do */


/* --- Wait for schema update procedure to delete strtlock. --- */
ASSIGN
  Mtime-out = 0.
DO WHILE SEARCH("rtb_idat~/strtlock") <> ?:
   PAUSE 1 NO-MESSAGE.
   ASSIGN
     Mtime-out = Mtime-out + 1.
   IF Mtime-out > 30 THEN
     LEAVE.
END.

/* --- Wait for post schema update procedure to delete runlock. --- */
ASSIGN
  Mlock-removed = NO.
DO WHILE NOT Mlock-removed:
   /* --- Report progress to user. --- */
   IF SEARCH("rtb_idat~/runlock") = ? THEN
      ASSIGN
         Mlock-removed = YES.
   PAUSE 1 NO-MESSAGE.
   IF SEARCH("rtb_ilog~/schupdp2.log") <> ? THEN DO:
      INPUT STREAM Sin1 FROM "rtb_ilog~/schupdp2.log" NO-ECHO.
      SEEK STREAM Sin1 TO END.
      ASSIGN
         Mseek = SEEK(Sin1).
      IF Mfilepos < Mseek THEN DO:
         SEEK STREAM Sin1 TO Mfilepos.
         REPEAT:
            IMPORT STREAM Sin1 UNFORMATTED Mline.
            ASSIGN
               Mreturn-value = Pmsg:INSERT-STRING(Mline + CHR(10)).
         END.  /* repeat */
         ASSIGN
            Mfilepos = Mseek.
      END.  /* if mfilepos < seek(input) */
      INPUT CLOSE.
   END.  /* if search ... */
END.  /* do while search ... */


/* --- Check schupdp2 error file. --- */
FILE-INFO:FILE-NAME = "rtb_ilog~/schupdp2.err".
IF FILE-INFO:FULL-PATHNAME <> ? THEN DO:
   INPUT FROM VALUE(FILE-INFO:FULL-PATHNAME) UNBUFFERED NO-ECHO.
   ASSIGN
      Mschema-error = NO.
   REPEAT:
      IMPORT UNFORMATTED Mline.
      ASSIGN
         Mreturn-value = Pmsg:INSERT-STRING(Mline + CHR(10))
         Mschema-error = YES.
   END.  /* repeat */
   IF Mschema-error THEN DO:
      ASSIGN
         Mreturn-value = Pmsg:INSERT-STRING(CHR(10) +
                         "Post-schema update processing failed." +
                         CHR(10)).
      RETURN "Failed".
   END.   /* if mschema-error */
END.  /* if file-info ... */
ELSE DO:
   ASSIGN
      Mreturn-value = Pmsg:INSERT-STRING("Post-schema update failed as " +
                      "schupdp2.p did not execute." +
                      CHR(10)).
   RETURN "Failed".
END.  /* else do */

Mreturn-value = Pmsg:INSERT-STRING("Post-schema update processing complete." +
                                   CHR(10)).  

RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ScreenSetup WINDOW-1 
PROCEDURE ScreenSetup :
/*------------------------------------------------------------------------------
  Purpose: Prepare the two user interfaces (Character and GUI).
           - Modify Frame size.
           - Add text.    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

/* --- Add text to the Splash screen. --- */
DISPLAY
   "Welcome to the {&APPLICATION-NAME} Setup and Update procedure."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    This procedure takes you through the process of creating or updating the"
      VIEW-AS TEXT
   SKIP
   "    {&APPLICATION-NAME} database and compiling {&APPLICATION-NAME} procedures."
      VIEW-AS TEXT
   SKIP(1)
   "    The process is presented as a series of instruction pages."
      VIEW-AS TEXT
   SKIP(1)
   "    Use the Next and Back buttons to move through the pages to perform each"
      VIEW-AS TEXT
   SKIP
   "    step of the update process."
      VIEW-AS TEXT
WITH FRAME FRAME-Splash.


/* --- Add text to the screen that prompts for PROGREES path. --- */
DISPLAY
   "Specify the PROGRESS Directory."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    The PROGRESS directory is required to run Database Update rountines and"
      VIEW-AS TEXT
   SKIP
   "    compile {&APPLICATION-NAME} procedures.  Specify the PROGRESS directory."
   SKIP(2)
   "              PROGRESS Directory:"
WITH FRAME FRAME-Get-dlc-path.
         
                                   
/* --- Make Introduction frame longer and move Radio set down for TTY. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN
      FRAME FRAME-Intro:HEIGHT-CHARS = 20
      RADIO-SET-DBupdate:ROW         = 16.

/* --- Add text to the Introduction screen. --- */        
DISPLAY
   "Select the Type of Database Update Required."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT 
   SKIP(1)
   "    This setup and update process creates or updates your database and then"
      VIEW-AS TEXT
   SKIP
   "    compiles the {&APPLICATION-NAME} client.  If the {&APPLICATION-NAME} database is already"
      VIEW-AS TEXT
   SKIP
   "    up to date, having been updated from another client, then select the"
      VIEW-AS TEXT
   SKIP
   "    ~"Skip schema update~" option below." VIEW-AS TEXT
   SKIP(1)
   "    NOTE: If this is your first install and your database is a networked"
      VIEW-AS TEXT
   SKIP
   "    server, then you will have to manually create a new empty server"
      VIEW-AS TEXT
   SKIP
   "    database, start the server, and then update the schema from this client"
      VIEW-AS TEXT
   SKIP
   "    connection by selecting the ~"Update schema of existing database~""
      VIEW-AS TEXT
   SKIP
   "    option below."
      VIEW-AS TEXT
WITH FRAME FRAME-Intro.


/* --- Make New Local Database frame longer, move DB Name fill-in and
       hide the Browse button (as it is not supported in Character). --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN
      FRAME FRAME-DBLocal:HEIGHT-CHARS               = 20
      FILL-IN-NewDBLoc:ROW                           = 15
      BUTTON-Browse-2:VISIBLE IN FRAME FRAME-DBLocal = NO.
      
/* --- Add text to the New Local Database screen. --- */  
DISPLAY
   "Create New Local {&APPLICATION-NAME} Database."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    Specify a location and name for the new {&APPLICATION-NAME} database.  Do not" 
      VIEW-AS TEXT
   SKIP
   "    place the {&APPLICATION-NAME} database in the PROGRESS directory structure as it"
      VIEW-AS TEXT
   SKIP
   "    could be deleted in a future PROGRESS update."
      VIEW-AS TEXT
   SKIP(1)
   "    NOTE: If a database already exists, it will not be overwritten."
      VIEW-AS TEXT
   SKIP(1)
   "    Choose the Next button to create the database." 
      VIEW-AS TEXT
   SKIP(2)
   "              New database's location and name:"
      VIEW-AS TEXT
WITH FRAME FRAME-DBLocal.


/* --- Make Database Parameters File frame longer, move PF file Name fill-in and
       hide the Browse button (as it is not supported in Character). --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN
      FRAME FRAME-OBJGetPF:HEIGHT-CHARS               = 20
      FILL-IN-compile-pf:ROW                          = 15
      BUTTON-Browse-3:VISIBLE IN FRAME FRAME-OBJGetPF = NO.

/* --- Add text to the Database Parameters File screen. --- */  
DISPLAY
   "Specify Location of Database Parameters File Used for Compilation."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    Specify the location of the Progress parameters file that contains the"
      VIEW-AS TEXT
   SKIP
   "    connection parameters for the {&APPLICATION-NAME} compile.  If the parameters"
      VIEW-AS TEXT
   SKIP
   "    does not yet exist then it will be created for you."
      VIEW-AS TEXT
   SKIP
   "    Name this parameters file compile.pf."
      VIEW-AS TEXT
   SKIP(1)
   "    NOTE: Do not place this parameters file in the PROGRESS installation"
      VIEW-AS TEXT
   SKIP
   "    directory as it might be deleted by a future PROGRESS update."
      VIEW-AS TEXT
   SKIP(2)
   "              Location of Progress parameters file for compile:"
      VIEW-AS TEXT
WITH FRAME FRAME-OBJGetPF.


/* --- Make Database Parameters File frame longer, move PF file Name fill-in and
       hide the Browse button (as it is not supported in Character). --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN
      FRAME FRAME-OBJEditPF:HEIGHT-CHARS = 20
      EDITOR-OBJPFFILE:ROW               = 11 
      EDITOR-OBJPFFILE:INNER-LINES       = 7 
      BUTTON-New-pfentry-2:ROW           = 11.

/* --- Add text to the Database Parameters Edit screen. NOTE" The blank
       lines are neccessary to hide the original placement of the
       editor widget, do not remove them.  --- */  
DISPLAY
   "Edit the Database Parameters File for {&APPLICATION-NAME} Compiles."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP
   "                                                                            "
         VIEW-AS TEXT
   SKIP
   "    This parameters file controls the connection of the {&APPLICATION-NAME} database "
      VIEW-AS TEXT
   SKIP
   "    for compilation of {&APPLICATION-NAME} procedures.                               "
      VIEW-AS TEXT
   SKIP
   "                                                                            "
         VIEW-AS TEXT
   SKIP
   "    Use the pf Entry button to create new database connection parameter     "
      VIEW-AS TEXT
   SKIP
   "    entries.  Edit the entries in the editor below.                         "
      VIEW-AS TEXT
WITH FRAME FRAME-OBJEditPF.


/* --- Make Compiled Code Directory frame longer and move FILL-IN down for
       TTY. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN          
      FRAME FRAME-OBJGetTarget:HEIGHT-CHARS = 20
      FILL-IN-Rcode:ROW                     = 13.

DISPLAY
   "Specify Target Root Directory for Compiled Procedures."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    The compiled {&APPLICATION-NAME} application may be placed into a different"
      VIEW-AS TEXT
   SKIP
   "    directory structure than the source files. Please specify the root"
      VIEW-AS TEXT
   SKIP
   "    directory in which compiled {&APPLICATION-NAME} code will be placed. Make this"
      VIEW-AS TEXT
   SKIP
   "    field blank if you want the compiled {&APPLICATION-NAME} to reside under the same"
      VIEW-AS TEXT
   SKIP
   "    root directory as the {&APPLICATION-NAME} source."
      VIEW-AS TEXT
   SKIP(2)
   "              Compiled {&APPLICATION-NAME} root directory:"
      VIEW-AS TEXT
WITH FRAME FRAME-OBJGetTarget.


/* --- Make compile type frame longer and move RADIO-SET down for TTY. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN          
      FRAME FRAME-OBJCompile:HEIGHT-CHARS = 20
      RADIO-SET-CompileType:ROW           = 15.

DISPLAY
   "Select Type of Compile to Perform on {&APPLICATION-NAME} Client Source."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    You may choose to do either a full or incremental compile of {&APPLICATION-NAME}."
      VIEW-AS TEXT
   SKIP
   "    Choose to compile all procedures if this is the first time you have"
      VIEW-AS TEXT
   SKIP
   "    installed {&APPLICATION-NAME}."
      VIEW-AS TEXT
   SKIP(1)
   "    NOTE: If you have specified a different compiled {&APPLICATION-NAME} root"
      VIEW-AS TEXT
   SKIP
   "    directory than that used in a previous compile then you must perform a"
      VIEW-AS TEXT
   SKIP
   "    full compile."
      VIEW-AS TEXT
   SKIP(1)
   "    Choose the Next button to start the compilation process."
      VIEW-AS TEXT
WITH FRAME FRAME-OBJCompile.


/* --- Make prompt for schema database parameters file frame longer and move
       FILL-IN down for TTY. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN          
      FRAME FRAME-DBGetPF:HEIGHT-CHARS = 20
      FILL-IN-schema-pf:ROW            = 15
      BUTTON-Browse:VISIBLE            = NO.
      
DISPLAY
   "Specify the Location of the Database Parameters File for Schema Update."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    Please specify the location of the Progress parameters file that"
      VIEW-AS TEXT
   SKIP
   "    contains the connection parameters for the {&APPLICATION-NAME} database to be"
      VIEW-AS TEXT
   SKIP
   "    updated. If the parameters file does not yet exist then it will be"
      VIEW-AS TEXT
   SKIP
   "    created for you.  Name this parameters file schema.pf."
      VIEW-AS TEXT
   SKIP(1)
   "    NOTE: Do not place this parameters file in the PROGRESS installation"
      VIEW-AS TEXT
   SKIP
   "    directory as it might be deleted by a future PROGRESS update."
      VIEW-AS TEXT
   SKIP(2)
   "              Location of Progress parameters file:"
      VIEW-AS TEXT
WITH FRAME FRAME-DBGetPF.


/* --- Make edit schema database parameters frame longer and move FILL-IN down
       for TTY. --- */
IF SESSION:DISPLAY-TYPE = "TTY" THEN
   ASSIGN          
      FRAME FRAME-DBEditPF:HEIGHT-CHARS = 20
      EDITOR-PFFILE:ROW                 = 12
      EDITOR-PFFILE:INNER-LINES         = 5
      BUTTON-New-pfentry:ROW            = 12.

DISPLAY
   "Edit the Contents of the Database Parameters File for Schema Update."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP
   "                                                                       "
      VIEW-AS TEXT
   SKIP
   "    This file controls the connection to the {&APPLICATION-NAME} database in the"
      VIEW-AS TEXT
   SKIP
   "    schema update process.  Use the pf Entry button to create database"
      VIEW-AS TEXT
   SKIP
   "    connection parameter entries.  Use the editor below to edit"
      VIEW-AS TEXT
   SKIP
   "    entries.  Do not edit the line that begins #release= as this line is"
      VIEW-AS TEXT
   SKIP
   "    used by the update routine to keep track of the current release level"
      VIEW-AS TEXT
   SKIP
   "    of the {&APPLICATION-NAME} database."
      VIEW-AS TEXT
WITH FRAME FRAME-DBEditPF.


DISPLAY
   "Update Database Schemas of Existing Database."
      AT COLUMN 4 ROW 2
      VIEW-AS TEXT
   SKIP(1)
   "    Choose the Next button to start the process that updates the {&APPLICATION-NAME}"
      VIEW-AS TEXT
    SKIP
   "    database schemas.  This process may take a long time.  If the process is"
      VIEW-AS TEXT
   SKIP
   "    interrupted, you may restart it from this page."
      VIEW-AS TEXT
   SKIP(1)
   "    NOTE: The most common cause of failure in the schema update process is"
      VIEW-AS TEXT
   SKIP
   "    incorrect parameters in the Progress parameters file.  If you get such"
      VIEW-AS TEXT
   SKIP
   "    error, use the Back button to move to the previous page and review your"
      VIEW-AS TEXT
   SKIP
   "    database connection parameters.  Another common cause of failure is"
      VIEW-AS TEXT
   SKIP
   "    trying to update a database schema that has already been updated by"
      VIEW-AS TEXT
   SKIP
   "    another client."
      VIEW-AS TEXT
WITH FRAME FRAME-DBUpdate.


END PROCEDURE.  /* screensetup */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setRelease WINDOW-1 
PROCEDURE setRelease :
/* -----------------------------------------------------------
  Purpose: Changes the #release= line in the parameter file     
  Parameters: see below
  Notes:       
-------------------------------------------------------------*/
DEFINE INPUT PARAMETER PedHandle  AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER Pschema-pf AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Prelease   AS CHARACTER NO-UNDO.

DEFINE VARIABLE Mbuf AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mstr AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mi   AS INTEGER NO-UNDO.
DEFINE VARIABLE Mnum-entries AS INTEGER NO-UNDO.

Mbuf = PedHandle:SCREEN-VALUE.
Mnum-entries = NUM-ENTRIES(Mbuf,CHR(10)).

DO Mi = 1 TO Mnum-entries: 
   Mstr = TRIM(ENTRY(Mi, Mbuf, CHR(10))).
   IF Mstr BEGINS "#release=" THEN
      DO: 
      ENTRY(Mi, Mbuf, CHR(10)) = "#release=" + CAPS(Prelease).
      LEAVE.
      END.
END.

PedHandle:SCREEN-VALUE = Mbuf.

Mreturn-value = PedHandle:SAVE-FILE(Pschema-pf).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE UpdateCompctrl WINDOW-1 
PROCEDURE UpdateCompctrl :
/* ------------------------------------------------------------------------
  Purpose:    1) Process delctrl file.
              2) Merge the rtb_idat/selcomp, rtb_idat/objctrl and
                 rtb_inst/compctrl into one rtb_inst/compctrl file.
  Parameters: Pcompile-type - Type of compile to be performed.  Either
              "Full" or "Selective".
              Mmsg : Handle to the status window.
  Notes:      Create a rtb_inst/compctrl based on the content of
                - rtb_idat/selcomp : sent with release.  Indicates what
                  programs are to be selectively compiled.  May contain
                  "@@fullcomp" if a Full Compile is to be forced.
                - rtb_idat/objctrl : sent with release.  Contains
                  information on all objects contained in the release.
                  Indicates weather an object is to be updated "U",
                  added "A", or deleted "D" (the 3rd field - action).
                - rtb_inst/compctrl : exists at site.  Contains information
                  on all compilable objects at the site.
              
              The three above files are merged into one compctrl file
              based on the following:
              
                - Add programs to the compctrl file if they exist in the
                  objctrl file with an "action" of "A" or "U", and do not
                  exist in the compctrl file.
                - Delete programs from the compctrl file if they exist in
                  the objctrl file with an action of "D", and exist in the
                  compctrl file.
                - Do not alter programs that exist in the compctrl file,
                  but not in the objctrl file.
                                
                - If a Full compile is being performed:
                  Change the "action" field of all programs to "M", so they
                  get compiled by the compile process.
                - If a Selective compile is being performed:
                  If the selcomp file contains "@@fullcomp", change the
                  "action" field of all programs to "M", so they get
                  compiled by the compile process.
                  If the selcomp file contains program names, change the
                  "action" field of these programs to "M" (so they get 
                  compiled).  All other programs will have an "action" of
                  "C" (so they do not get compiled).
                  
              IMPORTANT: Both the rtb_idat/objctrl and the rtb_inst/compctrl
                         need to be maintained in sort order.
--------------------------------------------------------------------------*/

DEFINE INPUT PARAMETER Pcompile-type AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Mmsg          AS HANDLE NO-UNDO.

DEFINE VARIABLE Mstate                AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfilename             AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mcompctrl-read        AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Mcompctrl-found       AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Mobjctrl-read         AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Mobjctrl-found        AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Mcompctrl-object      AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mcompctrl-type        AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mcompctrl-action      AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mcompctrl-comp-params AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mcompctrl-save-into   AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mobjctrl-object       AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mobjctrl-type         AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mobjctrl-action       AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mobjctrl-comp-params  AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mobjctrl-save-into    AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mexport-object        AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mexport-type          AS INTEGER   NO-UNDO.
DEFINE VARIABLE Mexport-action        AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mexport-comp-params   AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mexport-save-into     AS CHARACTER NO-UNDO.


/* --- Create an error file. --- */
OUTPUT TO rtb_ilog~/objctrl.err NO-ECHO.


/* --- Read rtb_idat/delctrl file to delete obsolete source code. --- */
IF SEARCH("rtb_idat~/delctrl") <> ? THEN DO:
   Mreturn-value = Mmsg:INSERT-STRING("Deleting source programs contained " +
                   "in rtb_idat/delctrl..." + CHR(10)).

/* Need to handle the condition where delctrl if not existant */
IF SEARCH("rtb_inst~/delctrl") = ? THEN
   DO:
   OUTPUT STREAM Sout TO rtb_inst~/delctrl NO-ECHO.
   OUTPUT STREAM Sout CLOSE.
   END.

IF SEARCH("rtb_inst~\delctrl") = ? AND OPSYS <> "UNIX" THEN
   DO:
   OUTPUT STREAM Sout TO rtb_inst~\delctrl NO-ECHO.
   OUTPUT STREAM Sout CLOSE.
   END.

                   
   INPUT STREAM Sin FROM rtb_idat~/delctrl NO-ECHO.
   REPEAT ON ERROR UNDO,  LEAVE
          ON ENDKEY UNDO, LEAVE:
      IMPORT STREAM Sin Mfilename.
      ASSIGN
         Mfilename = SEARCH(Mfilename).
      IF Mfilename <> ? THEN DO:
         OS-DELETE SILENT VALUE(Mfilename).
      END. /* of Mfilename <> ? */
   END.  /* repeat */
   INPUT STREAM Sin CLOSE.
   Mreturn-value = Mmsg:INSERT-STRING("Finished deleting source." +
                   CHR(10) + CHR(10)).
END.  /* if search(rtb_idat/delctrl ... */


/* --- If this is a selective compile, read objects from selcomp to be
       selectively compiled into a temp-table. --- */
IF Pcompile-type = "Selective" AND SEARCH("rtb_idat~/selcomp") <> ? THEN DO:
   FOR EACH Tselective-comp:
      DELETE Tselective-comp.
   END.  /* for each tselective-comp */
   INPUT STREAM Sin FROM rtb_idat~/selcomp NO-ECHO.
   REPEAT ON ERROR UNDO,  LEAVE
          ON ENDKEY UNDO, LEAVE:
      IMPORT STREAM Sin Mfilename.
      CREATE Tselective-comp.
      ASSIGN
         Tselective-comp.object = Mfilename.
   END.  /* repeat */
   INPUT STREAM Sin CLOSE.   
END.  /* if pcompile-type = "selective" and ... */


/* --- Convert rtb_inst/compctrl file to the new rtb_idat/objctrl format
       with compile parameters instead of attribute space logical. --- */
IF SEARCH("rtb_inst~/compctrl") <> ? THEN DO:

   INPUT STREAM Sin FROM rtb_inst~/compctrl NO-ECHO.
   OUTPUT STREAM Sout TO rtb_inst~/comptemp NO-ECHO.
   
   REPEAT ON ERROR UNDO,  LEAVE
          ON ENDKEY UNDO, LEAVE:
      IMPORT STREAM Sin
         Mcompctrl-object
         Mcompctrl-type
         Mcompctrl-action
         Mcompctrl-comp-params
         Mcompctrl-save-into.
      EXPORT STREAM Sout
         Mcompctrl-object
         Mcompctrl-type
         Mcompctrl-action
         IF SESSION:DISPLAY-TYPE = "TTY" AND Mcompctrl-comp-params = "YES" THEN
            "ATTR-SPACE"
         ELSE IF SESSION:DISPLAY-TYPE = "TTY" AND Mcompctrl-comp-params = "NO" THEN
            "NO-ATTR-SPACE"
         ELSE IF SESSION:DISPLAY-TYPE <> "TTY" AND
                 (Mcompctrl-comp-params = "YES" OR Mcompctrl-comp-params = "NO") THEN
            ""
         ELSE
            Mcompctrl-comp-params
         Mcompctrl-save-into.      
   END.  /* repeat */

   INPUT STREAM Sin CLOSE.
   OUTPUT STREAM Sout CLOSE.

   OS-COPY "rtb_inst~/comptemp" "rtb_inst~/compctrl".

END.  /* if search(rtb_inst~/compctrl ... */


Mreturn-value = Mmsg:INSERT-STRING("Building new " + Pcompile-type +
                " compile rtb_inst/compctrl file..." +
                CHR(10)).


/* --- Create objctrl and compctrl files if they do not exist. --- */
IF SEARCH("rtb_idat~/objctrl") = ? THEN DO:
   OUTPUT STREAM Sout TO rtb_idat~/objctrl NO-ECHO.
   OUTPUT STREAM SOut CLOSE.
END.  /* if search("rtb_idat/objctrl ... */

IF SEARCH("rtb_inst~/compctrl") = ? THEN DO:
   OUTPUT STREAM Sout TO rtb_inst~/compctrl NO-ECHO.
   OUTPUT STREAM Sout CLOSE.
END.  /* if search("rtb_idat/compctrl ... */

IF SEARCH("rtb_inst~\compctrl") = ? AND OPSYS <> "UNIX" THEN
   DO:
   OUTPUT STREAM Sout TO rtb_inst~\compctrl NO-ECHO.
   OUTPUT STREAM Sout CLOSE.
   END.

/* --- Create the rtb_inst/compctrl file.  See procedure description above
       for details. --- */
INPUT STREAM Sin FROM rtb_idat~/objctrl NO-ECHO.
INPUT STREAM Sin2 FROM rtb_inst~/compctrl NO-ECHO.
OUTPUT STREAM Sout TO rtb_inst~/comptemp NO-ECHO.

/* --- Set variables to read a record from the compctrl and objctrl files. --- */
ASSIGN
   Mcompctrl-read = YES
   Mobjctrl-read  = YES.

/* --- Loop through rtb_idat/objctrl and rtb_inst/compctrl files. --- */
DO WHILE TRUE:

   /* --- Read record from compctrl. --- */
   IF Mcompctrl-read THEN DO:
      ASSIGN
         Mcompctrl-found = NO
         Mcompctrl-read  = NO.
      REPEAT ON ERROR  UNDO, LEAVE
             ON ENDKEY UNDO, LEAVE:
         IMPORT STREAM Sin2
            Mcompctrl-object
            Mcompctrl-type
            Mcompctrl-action
            Mcompctrl-comp-params
            Mcompctrl-save-into.
         ASSIGN
            Mcompctrl-found = YES.
         LEAVE.
      END.  /* on error */
   END.  /* if mcompctrl-read */

   /* --- Read record from objctrl. --- */
   IF Mobjctrl-read THEN DO:
      ASSIGN
         Mobjctrl-found = NO.
         Mobjctrl-read  = NO.
      REPEAT ON ERROR  UNDO, LEAVE
             ON ENDKEY UNDO, LEAVE:
         IMPORT STREAM Sin 
            Mobjctrl-object
            Mobjctrl-type
            Mobjctrl-action
            Mobjctrl-comp-params
            Mobjctrl-save-into.
         ASSIGN
            Mobjctrl-found = YES.
         LEAVE.
      END.  /* repeat */
   END.   /* if mobjctrl-read */
   
   
   IF Mcompctrl-found = NO AND Mobjctrl-found = NO THEN
      /* --- Reached the end of both files. --- */
      LEAVE.
   ELSE IF NOT Mobjctrl-found THEN
      /* --- Reached the end of objctrl, but not compctrl. Output 
             compctrl record to new compctrl. --- */
      ASSIGN
         Mcompctrl-read      = YES
         Mexport-object      = Mcompctrl-object
         Mexport-type        = Mcompctrl-type
         Mexport-action      = Mcompctrl-action
         Mexport-comp-params = Mcompctrl-comp-params
         Mexport-save-into   = Mcompctrl-save-into.
   ELSE IF NOT Mcompctrl-found THEN
      /* --- Reached the end of compctrl, but not objctrl. Output objctrl
             record to the new compctrl. --- */
      ASSIGN
         Mobjctrl-read       = YES
         Mexport-object      = Mobjctrl-object
         Mexport-type        = Mobjctrl-type
         Mexport-action      = Mobjctrl-action
         Mexport-comp-params = Mobjctrl-comp-params
         Mexport-save-into   = Mobjctrl-save-into.
   ELSE DO:
      /* --- Both compctrl and objctrl records exist. --- */
      IF Mcompctrl-object < Mobjctrl-object THEN
         /* --- Output compctrl record to new compctrl. --- */
         ASSIGN
            Mcompctrl-read      = YES
            Mexport-object      = Mcompctrl-object
            Mexport-type        = Mcompctrl-type
            Mexport-action      = Mcompctrl-action
            Mexport-comp-params = Mcompctrl-comp-params
            Mexport-save-into   = Mcompctrl-save-into.
      ELSE DO:
         /* --- Output objctrl record to new compctrl. --- */
         IF Mcompctrl-object = Mobjctrl-object THEN
            ASSIGN
               Mcompctrl-read = YES
               Mobjctrl-read  = YES.
         ELSE
            ASSIGN
               Mobjctrl-read = YES.
         ASSIGN
            Mexport-object      = Mobjctrl-object
            Mexport-type        = Mobjctrl-type
            Mexport-action      = Mobjctrl-action
            Mexport-comp-params = Mobjctrl-comp-params
            Mexport-save-into   = Mobjctrl-save-into.
      END.  /* else do */
   END.  /* else do */
     
   /* --- If object is to be deleted, do not add it to new compctrl. --- */
   IF Mexport-action = "D" THEN
      NEXT.
   
   /* --- Determine the action for the record.  Will be "M" if the object
          is to be compiled.  Will be "C" if the object does not require
          compile. --- */
   IF Pcompile-type = "Full" THEN
      ASSIGN
         Mexport-action = "M".
   ELSE DO:
      /* --- Selective compile. --- */
      IF CAN-FIND(FIRST Tselective-comp
                     WHERE Tselective-comp.object = Mexport-object) OR
         CAN-FIND(FIRST Tselective-comp
                     WHERE Tselective-comp.object = "@@fullcomp") THEN
         ASSIGN
            Mexport-action = "M".
      ELSE
         ASSIGN
            Mexport-action = "C".
   END.  /* else do */

   /* --- Export record to new compctrl file. --- */
   EXPORT STREAM Sout
      Mexport-object
      Mexport-type
      Mexport-action
      Mexport-comp-params
      Mexport-save-into.
 
END.  /* do while true */


OUTPUT STREAM Sout CLOSE.
INPUT STREAM Sin CLOSE.
INPUT STREAM Sin2 CLOSE.

OS-COPY "rtb_inst~/comptemp" "rtb_inst~/compctrl".

OUTPUT CLOSE.

Mreturn-value = Mmsg:INSERT-STRING("Finished building Compctrl file." +
                CHR(10) + CHR(10)).

RETURN.

 
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateSchema WINDOW-1 
PROCEDURE updateSchema :
/* -----------------------------------------------------------
  Purpose:This procedure calls the routines necessary to update
          the schema of the databases specified in the parameter
          file passed in the parameter.     
  Parameters: None
  Notes:  
-------------------------------------------------------------*/

DEFINE VARIABLE Merror          AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mname           AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfullname       AS CHARACTER NO-UNDO.
DEFINE VARIABLE McontinueUpdate AS LOGICAL   NO-UNDO.
DEFINE VARIABLE Merror-number   AS INTEGER   NO-UNDO.


DEFINE BUTTON updOkButton LABEL "OK" AUTO-GO SIZE 12 BY 1. 

DEFINE FRAME update-frame
   Mmsg
      NO-LABEL
      AT COLUMN 3 ROW 1.5
   SKIP
   updOkButton
      AT COLUMN 58 ROW 12
WITH
   SIZE 77 BY 14
   THREE-D
   SIDE-LABELS
   FONT 4
   DEFAULT-BUTTON updOkButton
   TITLE "Updating Database Schemas"
   VIEW-AS DIALOG-BOX.


/*
This update process works by copying the appropiate update files from
the rtb_dbup/{ver} directory into rtb_idat and then performing the update
on the databases specified in the database parameter file.

The update process has the ability to restart if it is interrupted. This
means that we do not want to overwrite any partially processed files in the
rtb_idat directory when restarting this routine. To make sure this does
not happen, we place a file in the rtb_idat directory called schlock at the
begining of the update process and remove it when the update process is
completed. While this file exists, the selection and copy of release files
from rtb_dbup/{ver} directories into rtb_idat is not supported.

*/

ASSIGN
   Mmsg = "".

RUN scanPfFile (INPUT  EDITOR-PFFILE:HANDLE IN FRAME FRAME-DBEditPF,
                OUTPUT MdbsInPf,
                OUTPUT MdbsVer,
                OUTPUT MdbCopies,
                OUTPUT Mrxneeded).

IF Mrxneeded THEN
  DO:
    RUN rx_message.
    RETURN "Error".
  END.

/* --- Look for a schlock file in the rtb_idat directory --- */
ASSIGN
   FILE-INFO:FILE-NAME = "rtb_idat~/schlock".
IF FILE-INFO:FULL-PATHNAME <> ? THEN DO: 
   MESSAGE 
      "A schema lock file ('schlock') file exists in the rtb_idat directory."
      SKIP
      "This usually means that you are trying to restart the update process " +
      "after an unexpected failure. If this is the case you should choose OK " +
      "to continue.  If this is not the case, you should choose CANCEL to " +
      "abort this operation and contact technical support."
      VIEW-AS ALERT-BOX WARNING
      BUTTONS OK-CANCEL
      TITLE Malert-title
      UPDATE McontinueUpdate.
   IF NOT McontinueUpdate THEN
      RETURN "Error".  
END.  /* if file-infor:full-pathname = ? */


/* --- Get correct release from user and copy files into rtb_idat. --- */
RUN get_new_version.
IF RETURN-VALUE = "Error" THEN RETURN "Error".
IF RETURN-VALUE = "Skip" THEN RETURN.


/* --- Copy schema update files into the rbt_idat directory --- */
RUN xcopy("rtb_dbup~/" + MverDir,"rtb_idat","").      

/* --- Expand the schctrl file for each database copy defined in the
       parameter file by a #dbcopy= line --- */
RUN expandSchctrl.
/* --- Write schlock file. --- */
OUTPUT TO VALUE("rtb_idat~/schlock") UNBUFFERED NO-ECHO.
PUT UNFORMATTED "This file prevents the deletion of partially processed schctrl files".
OUTPUT CLOSE.

DISPLAY
   Mmsg
   updOkButton
WITH FRAME update-frame.

ENABLE
   Mmsg
WITH FRAME update-frame.

APPLY "ENTRY" TO Mmsg IN FRAME update-frame.

ASSIGN
   Mmsg:READ-ONLY = TRUE.

/* --- Start wait state. --- */
Mreturn-value = SESSION:SET-WAIT-STATE("GENERAL").

Mreturn-value = Mmsg:INSERT-STRING("Starting schema update.   Please wait..." +
                                   CHR(10) +
                                   CHR(10)).


/* --- Ensure the database defined in the schema.pf will connect (check
       the connection parameters). --- */
Mreturn-value = Mmsg:INSERT-STRING("Checking database connection " +
                "parameters..." + CHR(10)).
CONNECT -pf VALUE(FILL-IN-schema-pf) NO-ERROR.
IF ERROR-STATUS:ERROR THEN DO:
   Mreturn-value = Mmsg:INSERT-STRING("Database could not be connected." +
                   CHR(10) + CHR(10)).
   DO Merror-number = 1 TO ERROR-STATUS:NUM-MESSAGES:
      ASSIGN
         Merror = ERROR-STATUS:GET-MESSAGE(Merror-number).
      Mreturn-value = Mmsg:INSERT-STRING(Merror + CHR(10)).
   END.  /* do merror-number ... */
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + 
                   "Schema update failed as the database contained in " +
                   FILL-IN-schema-pf +
                   " could not be connected.  Ensure connection " +
                   "parameters are correct." +
                   CHR(10) + CHR(10) +
                   "Update failed.  Review log above.  Press OK to continue." +
                   CHR(10)).
   /* --- Wait for user to press OK before continuing. --- */
   Mreturn-value = SESSION:SET-WAIT-STATE("").
   ENABLE
      updOkButton
   WITH FRAME update-frame.
   WAIT-FOR GO OF FRAME update-frame.
   HIDE FRAME update-frame.
   RETURN "Failed".
END.  /* if error-status:error */
/* --- Disconnect database. --- */
RUN disconnectAll.
Mreturn-value = Mmsg:INSERT-STRING("Connection parameters correct." + 
                CHR(10) + CHR(10)).


/* --- Compile the schema update programs. --- */
RUN compileUpdateProcs (INPUT  FILL-IN-schema-pf,
                        INPUT  Mmsg:HANDLE).
IF RETURN-VALUE <> "" THEN DO:
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + 
                   "Schema update failed as errors occurred during the " +
                   "compile of the schema update programs." +
                   CHR(10) + CHR(10) +
                   "Update failed.  Review log above.  Press OK to continue." +
                   CHR(10)).
   /* --- Wait for user to press OK before continuing. --- */
   Mreturn-value = SESSION:SET-WAIT-STATE("").
   ENABLE
      updOkButton
   WITH FRAME update-frame.
   WAIT-FOR GO OF FRAME update-frame.
   HIDE FRAME update-frame.
   /* --- Change the #release= line in the .pf file to failed schema
          update. --- */
   RUN setRelease (INPUT  EDITOR-PFFILE:HANDLE,
                   INPUT  FILL-IN-schema-pf,
                   INPUT  "failed schema update " +
                          MdbsVer +
                          " to " +
                          Mnewver).
   RETURN "Failed".                 
END.  /* if return-value <> "" */


/* --- Execute pre-schema update processing and perform schema update. --- */
/* --- Change the #release= line in .pf file to installing schema
          update. --- */
RUN setRelease (INPUT  EDITOR-PFFILE:HANDLE,
                INPUT  FILL-IN-schema-pf,
                INPUT  "installing schema update " +
                       MdbsVer +
                       " to " +
                       MnewVer).
PAUSE 10 NO-MESSAGE.
RUN schemaUpdate1 (INPUT  FILL-IN-schema-pf,
                   INPUT  Mmsg:HANDLE).
IF RETURN-VALUE <> "" THEN DO:
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + 
                   "Schema update failed as errors occurred during the " +
                   "pre-schema update processing or schema update." +
                   CHR(10) + CHR(10) +
                   "Update failed.  Review log above.  Press OK to continue." +
                   CHR(10)).
   /* --- Wait for user to press OK before continuing. --- */
   Mreturn-value = SESSION:SET-WAIT-STATE("").
   ENABLE
      updOkButton
   WITH FRAME update-frame.
   WAIT-FOR GO OF FRAME update-frame.
   HIDE FRAME update-frame.
   /* --- Change the #release= line in the .pf file to failed schema
          update. --- */
   RUN setRelease (INPUT  EDITOR-PFFILE:HANDLE,
                   INPUT  FILL-IN-schema-pf,
                   INPUT  "failed schema update " +
                          MdbsVer +
                          " to " +
                          Mnewver).   
   RETURN "Failed".                 
END.  /* if return-value <> "" */


/* --- Execute post-schema update processing. --- */
RUN schemaUpdate2 (INPUT  FILL-IN-schema-pf,
                   INPUT  Mmsg:HANDLE).
IF RETURN-VALUE <> "" THEN DO:
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + 
                   "Schema update failed as errors occurred during the " +
                   "post schema update processing." +
                   CHR(10) + CHR(10) +
                   "Update failed.  Review log above.  Press OK to continue." +
                   CHR(10)).
   /* --- Wait for user to press OK before continuing. --- */
   Mreturn-value = SESSION:SET-WAIT-STATE("").
   ENABLE
      updOkButton
   WITH FRAME update-frame.
   WAIT-FOR GO OF FRAME update-frame.
   HIDE FRAME update-frame.
   /* --- Change the #release= line in the .pf file to failed schema
          update. --- */
   RUN setRelease (INPUT  EDITOR-PFFILE:HANDLE,
                   INPUT  FILL-IN-schema-pf,
                   INPUT  "failed schema update " +
                          MdbsVer +
                          " to " +
                          Mnewver).
   RETURN "Failed".                 
END.  /* if return-value <> "" */


/* --- Change the #release= line in the .pf file to new release level. --- */
RUN setRelease (INPUT  EDITOR-PFFILE:HANDLE,
                INPUT  FILL-IN-schema-pf,
                INPUT  MnewVer).


/* --- Clean up schema update files. --- */ 
RUN DeleteTempdata.
INPUT FROM OS-DIR("rtb_idat").
REPEAT:
   IMPORT Mname Mfullname.
   IF Mname MATCHES "schlock" OR
      Mname MATCHES "schctrl" OR
      Mname MATCHES "*d.p" OR
      Mname MATCHES "*d.r" OR
      Mname MATCHES "*f.p" OR
      Mname MATCHES "*f.r" OR
      Mname MATCHES "*.df" THEN
      OS-DELETE VALUE(Mfullname).
END.  /* repeat */


/* --- Ensure a UNIX rtb.pf file exists. If it doesn't, create it. ---
 * This is specific to Roundtable (Mroundtable = YES).
 * ------------------------------------------------------------------- */
IF ( Mroundtable
     AND SESSION:DISPLAY-TYPE = "TTY"
     AND SEARCH("rtb.pf") = ?
    ) THEN DO:

  ASSIGN
     Mreturn-value = Mmsg:INSERT-STRING(SUBSTITUTE("&1Creating rtb.pf
 startup parameter file from &2...&1",CHR(10),FILL-IN-schema-pf)).

  RUN create_rtbpf.

  IF RETURN-VALUE = "" THEN
    ASSIGN
      Mreturn-value = Mmsg:INSERT-STRING(SUBSTITUTE("Finished creating
 rtb.pf parameter file.",CHR(10))).
  ELSE
    ASSIGN
      Mreturn-value = Mmsg:INSERT-STRING(SUBSTITUTE("Can not create
 rtb.pf startup parameter file.&1Manually create this parameter file before
 running {&APPLICATION-NAME}.&1",CHR(10))).
END.  /* if session:display-tupe = "tty" and ... */


/* --- Inform user that schema processing is complete. --- */          
ASSIGN
   Mreturn-value = Mmsg:INSERT-STRING(CHR(10) + CHR(10) +
                   "Schema update is complete.  Press OK to continue." +
                   CHR(10)).   
                   
/* --- Wait for user to press OK before continuing. --- */
Mreturn-value = SESSION:SET-WAIT-STATE("").
ENABLE
   updOkButton
WITH FRAME update-frame.
WAIT-FOR GO OF FRAME update-frame.
HIDE FRAME update-frame.   

RETURN.

  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE xcopy WINDOW-1 
PROCEDURE xcopy :
/* --------------------------------------------------------------------
  Purpose:     Simulate the xcopy function
  Parameters:  Source Directory, Target Directory
  Notes:       
   -------------------------------------------------------------------- */
DEFINE INPUT PARAMETER Psource AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Ptarget AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Poption AS CHARACTER NO-UNDO.

DEFINE VARIABLE SubDirName AS CHARACTER NO-UNDO.
DEFINE VARIABLE SubDirPath AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfilename  AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfullpath  AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfile-type AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mi         AS INTEGER   NO-UNDO.
DEFINE VARIABLE Merror     AS CHARACTER NO-UNDO.

  IF Psource = Ptarget THEN RETURN.

  IF Ptarget MATCHES "*~/" 
     THEN RUN makeDirectory(Ptarget,OUTPUT Merror).
     ELSE RUN makeDirectory(Ptarget + "~/",OUTPUT Merror).

  INPUT FROM OS-DIR (Psource) NO-ECHO.
  REPEAT:
    IMPORT Mfilename Mfullpath Mfile-type.
    IF NOT Mfilename BEGINS "." THEN
       DO:
       IF INDEX(Mfile-type, "D") > 0 THEN
          ASSIGN
          SubDirName = SubDirName + Mfilename + ","
          SubDirPath = SubDirPath + Mfullpath + ",".
       ELSE
          DO:
          /* If UNIX, use cp. OS-COMMAND does not preserve file permissions.
           * This is important for things like shell scripts.
           */
          IF OPSYS = "UNIX":U THEN
             OS-COMMAND SILENT VALUE
                ("cp " + Mfullpath + " " + Ptarget + "~/" + Mfilename).
          ELSE
             OS-COPY VALUE(Mfullpath) VALUE(Ptarget + "~/" + Mfilename).
          END.
       END.
   END.
   INPUT CLOSE.
   
   IF Poption = "S" THEN   
      DO Mi = 1 TO NUM-ENTrIES(SubDirName) - 1 :
      
         RUN Xcopy(ENTRY(Mi, SubDirPath)
                   ,Ptarget + "~/" + ENTRY(Mi, SubDirName)
                   ,"S").
      END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnOsQuote WINDOW-1 
FUNCTION fnOsQuote RETURNS CHARACTER
  ( Parg AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Quote supplied command line argument if it contains embedded
            spaces.
    Notes:  
------------------------------------------------------------------------------*/
  IF INDEX(Parg," ") > 0 THEN
    Parg = "~"" + Parg + "~"".
  
  IF OPSYS = "UNIX" THEN
    Parg = REPLACE(Parg,"~\","~/").
  ELSE
    Parg = REPLACE(Parg,"~/","~\").
  
  RETURN Parg.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

