&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME DIALOG-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS DIALOG-1 
/*------------------------------------------------------------------------
  File: rtb_wdif.w
  Description: Workspace Differences Report.
  Author: Erie D. Mead.
  Created: 3/1/95
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

{rtb/g/rtbglobl.i NEW}     /* Roundtable globals          */
{rtb/g/rtbrptv.i}          /* print destination variables */

/* --- Define Locals --- */
DEFINE BUFFER Brtb_ver     FOR rtb.rtb_ver.
DEFINE BUFFER Brtb_object  FOR rtb.rtb_object.
DEFINE BUFFER Brtb_object2 FOR rtb.rtb_object.

DEFINE VARIABLE BT-Ok        AS HANDLE             NO-UNDO.
DEFINE VARIABLE BT-Help      AS HANDLE             NO-UNDO.
DEFINE VARIABLE BT-Cancel    AS HANDLE             NO-UNDO.
DEFINE VARIABLE Mdsp-wspace1 AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mdsp-wspace2 AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mtitle       AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mlabel       AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mline        AS CHARACTER          NO-UNDO.
DEFINE VARIABLE Mret         AS LOGICAL            NO-UNDO.
DEFINE VARIABLE Mdone-report AS LOGICAL INITIAL NO NO-UNDO.

/* End of Defines */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DIALOG-1

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS Mwspace-id1 Mwspace-id2 
&Scoped-Define DISPLAYED-OBJECTS Mwspace-id1 Mwspace-id2 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE VARIABLE Mwspace-id1 AS CHARACTER FORMAT "X(32)":U 
     LABEL "&First Workspace" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 5
     DROP-DOWN-LIST
     SIZE 24 BY 1 NO-UNDO.

DEFINE VARIABLE Mwspace-id2 AS CHARACTER FORMAT "X(16)":U 
     LABEL "&Second Workspace" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     DROP-DOWN-LIST
     SIZE 24 BY 1 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DIALOG-1
     Mwspace-id1 AT ROW 2 COL 25 COLON-ALIGNED HELP
          "Enter the first workspace id."
     Mwspace-id2 AT ROW 3.29 COL 25 COLON-ALIGNED HELP
          "Enter the second workspace id."
     SPACE(5.99) SKIP(3.80)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 4
         TITLE "Workspace Differences Report":L.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX DIALOG-1
                                                                        */
ASSIGN 
       FRAME DIALOG-1:SCROLLABLE       = FALSE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME DIALOG-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL DIALOG-1 DIALOG-1
ON GO OF FRAME DIALOG-1 /* Workspace Differences Report */
DO:
    IF SESSION:DISPLAY-TYPE = "TTY":U THEN
      RUN disable_UI.

    ASSIGN
      Mwspace-id1 = Mwspace-id1:SCREEN-VALUE
      Mwspace-id2 = Mwspace-id2:SCREEN-VALUE.
      
    /**  validate wspace 1 **/
    FIND FIRST Brtb_object
      WHERE Brtb_object.wspace-id = Mwspace-id1
      NO-LOCK NO-ERROR.
      
    IF NOT AVAILABLE Brtb_object THEN
    DO:
    
      MESSAGE "Sorry!  Workspace 1 does not exist.".
      APPLY "ENTRY" TO Mwspace-id1 IN FRAME {&FRAME-NAME}.
      RETURN NO-APPLY.
      
    END.
    
    /**  validate workspace 2  **/
    FIND FIRST Brtb_object 
      WHERE Brtb_object.wspace-id = Mwspace-id2
      NO-LOCK NO-ERROR.
      
    IF NOT AVAILABLE Brtb_object THEN
    DO:
    
      MESSAGE "Sorry!  Workspace 2 does not exist.".
      APPLY "ENTRY" TO Mwspace-id2 IN FRAME {&FRAME-NAME}.
      RETURN NO-APPLY.
      
    END.   
    
    RUN do_report.     

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK DIALOG-1 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.

/* Add Trigger to equate WINDOW-CLOSE to END-ERROR                      */
ON WINDOW-CLOSE OF FRAME {&FRAME-NAME} APPLY "END-ERROR":U TO SELF.

ASSIGN 
  Mwspace-id1:LIST-ITEMS IN FRAME {&FRAME-NAME} = ""
  Mwspace-id2:LIST-ITEMS IN FRAME {&FRAME-NAME} = "".

FOR EACH rtb.rtb_wspace NO-LOCK:
  Mret = Mwspace-id1:ADD-LAST( rtb.rtb_wspace.wspace-id ) 
    IN FRAME {&FRAME-NAME}.
  Mret = Mwspace-id2:ADD-LAST( rtb.rtb_wspace.wspace-id )
    IN FRAME {&FRAME-NAME}.
END.

IF CAN-DO( Grtb-wspace-id, Mwspace-id1:LIST-ITEMS ) THEN
  ASSIGN
    Mwspace-id1 = Grtb-wspace-id
    Mwspace-id2 = Grtb-wspace-id.
ELSE
  ASSIGN
    Mwspace-id1 = ENTRY(1,Mwspace-id1:LIST-ITEMS)
    Mwspace-id2 = ENTRY(1,Mwspace-id2:LIST-ITEMS). 

IF SESSION:DISPLAY-TYPE <> "TTY":U THEN
  DO:
    RUN make_def_ok_cancel IN Grtb-p-library (INPUT  FRAME {&FRAME-NAME}:HANDLE,
                                              OUTPUT BT-Ok,
                                              OUTPUT BT-Cancel,
                                              OUTPUT BT-Help).
    ON CHOOSE OF BT-help OR HELP OF FRAME {&FRAME-NAME} DO:
      SYSTEM-HELP Grtb-help-file CONTEXT 619.
    END.             
  END.
ELSE
  DO:
    {rtb/g/rtb_okcan.i "{&FRAME-NAME}"}
  END.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
RUN enable_UI.
MAIN-BLOCK:
DO WHILE NOT Mdone-report
   ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK: 

  IF NOT FRAME {&FRAME-NAME}:VISIBLE THEN
    RUN enable_UI.

  WAIT-FOR GO OF FRAME {&FRAME-NAME}.

END. 

IF FRAME {&FRAME-NAME}:VISIBLE THEN
  RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI DIALOG-1  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME DIALOG-1.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE do_report DIALOG-1 
PROCEDURE do_report :
/* -----------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
-------------------------------------------------------------*/
  DEFINE VARIABLE Mmsg   AS CHARACTER  NO-UNDO
                         INITIAL "No differences found.".
  DEFINE VARIABLE Mdiff  AS LOGICAL    NO-UNDO INITIAL NO.
  
  {rtb/g/rtbrpt1.i} /* set print destination */

  ASSIGN
    Mdone-report = YES
    Mdsp-wspace1 = TRIM( Mwspace-id1 )
    Mdsp-wspace2 = TRIM( Mwspace-id2 )
    Mtitle       = "Objects in workspace: " +
                   TRIM( Mdsp-wspace1 ) +
                   " but not in workspace: " +
                   TRIM( Mdsp-wspace2 )
    Mlabel       = "Objects         Type    Version Description"
    .

  FORM
    Mmsg FORMAT "x(70)" AT 4
  WITH FRAME no-diff-frame
    NO-BOX
    NO-LABELS
    NO-ATTR-SPACE
    STREAM-IO.

  FORM HEADER
    TODAY  FORMAT "99/99/99"                                    AT 1
    "Workspace Differences Report - rtb_wdif.w"                 AT 14
    "Page:"                                                     AT 61
    PAGE-NUMBER FORMAT ">>9"                              AT 68 SKIP
    Mtitle    FORMAT "X(74)"     AT 1 SKIP(1)
    Mlabel    FORMAT "X(74)"     AT 1 SKIP
  WITH FRAME header-frame
    NO-BOX
    PAGE-TOP
    STREAM-IO
    NO-ATTR-SPACE
    NO-LABELS
    .
        
  FORM HEADER
    TODAY  FORMAT "99/99/99"                                    AT 1
    "Workspace Differences Report - rtb_wdif.w"                 AT 14
    "Page:"                                                     AT 61
    PAGE-NUMBER FORMAT ">>9"                              AT 68 SKIP
    Mtitle  FORMAT "X(74)"      AT 1 SKIP(1)     
  WITH FRAME short-header-frame
    CENTERED
    NO-BOX
    STREAM-IO
    NO-ATTR-SPACE
    PAGE-TOP
    NO-LABELS.
    
  IF Grtb-prn-dest = "T" THEN VIEW FRAME short-header-frame.
  ELSE VIEW FRAME header-frame.
  
  FOR EACH Brtb_object
    WHERE Brtb_object.wspace-id = Mdsp-wspace1
    NO-LOCK,
    EACH Brtb_ver OF Brtb_object
    NO-LOCK:

    FIND FIRST Brtb_object2
      WHERE Brtb_object2.wspace-id   = Mdsp-wspace2
      AND   Brtb_object2.obj-type    = Brtb_object.obj-type
      AND   Brtb_object2.object      = Brtb_object.object
      NO-LOCK NO-ERROR.

    IF NOT AVAILABLE Brtb_object2 THEN
    DO:

      Mline = STRING( Brtb_object.object,      "X(14)" )  + "  " +
              STRING( Brtb_object.obj-type,    "X(06)" )  + "  " +
              STRING( Brtb_object.version,     "999999" ) + "  " +
              STRING( Brtb_ver.description, "X(40)" )
              . 
      
      DISPLAY
        Mline  FORMAT "X(78)"
      WITH FRAME workspace-1-frame
        NO-ATTR-SPACE
        NO-LABELS
        NO-BOX
        STREAM-IO
        .    
      Mdiff = YES.
    END.
  END.
  
  IF NOT Mdiff THEN
    DISPLAY Mmsg WITH FRAME no-diff-frame.
  ELSE
    Mdiff = NO.

  Mtitle = 
    "Objects in workspace: " +
    TRIM( Mdsp-wspace2 ) +
    " but not in workspace: " +
    TRIM( Mdsp-wspace1 )
    .
 
  DISPLAY "" WITH FRAME force-frame STREAM-IO. 
  PAGE.

        
  FOR EACH Brtb_object
    WHERE Brtb_object.wspace-id = Mdsp-wspace2
    NO-LOCK,
    EACH Brtb_ver OF Brtb_object
    NO-LOCK:

    FIND FIRST Brtb_object2
      WHERE Brtb_object2.wspace-id   = Mdsp-wspace1
      AND   Brtb_object2.obj-type    = Brtb_object.obj-type
      AND   Brtb_object2.object      = Brtb_object.object
      USE-INDEX rtb_object4 NO-LOCK NO-ERROR.

    IF NOT AVAILABLE Brtb_object2 THEN
    DO:
    
      Mline = STRING( Brtb_object.object,      "X(14)" )  + "  " +
              STRING( Brtb_object.obj-type,    "X(06)" )  + "  " +
              STRING( Brtb_object.version,     "999999" ) + "  " +
              STRING( Brtb_ver.description, "X(40)" )
              . 
      
      DISPLAY
        Mline  FORMAT "X(78)"
      WITH FRAME workspace-2-frame
        NO-ATTR-SPACE
        NO-LABELS
        NO-BOX
        STREAM-IO
        .    
      Mdiff = YES.
    END.  /* if not avaiable Brtb_object2 */
  END.  /* for each Brtb_object */

  IF NOT Mdiff THEN
    DISPLAY Mmsg WITH FRAME no-diff-frame.
  ELSE
    Mdiff = NO.

  ASSIGN
    Mtitle = "Objects with different versions"
    Mlabel = "Object         Type   Wrkspace1    Version" + 
             "Wrkspace2    Version Description"
             .


  DISPLAY "" WITH FRAME force-frame stream-io.
  PAGE.
            
  FOR EACH Brtb_object
    WHERE Brtb_object.wspace-id = Mdsp-wspace1
    NO-LOCK,
    EACH Brtb_ver OF Brtb_object
    NO-LOCK:

    FIND FIRST Brtb_object2
      WHERE Brtb_object2.wspace-id   = Mdsp-wspace2
      AND   Brtb_object2.obj-type    = Brtb_object.obj-type
      AND   Brtb_object2.object      = Brtb_object.object
      USE-INDEX rtb_object4 NO-LOCK NO-ERROR.

    IF AVAILABLE Brtb_object2 THEN
    DO:
      
      IF Brtb_object.version <> Brtb_object2.version THEN
      DO:
        Mline = STRING( Brtb_object.object,   "X(14)" )  + " " +
                STRING( Brtb_object.obj-type, "X(06)" )  + " " +
                STRING( Mdsp-wspace1,         "X(12)" )  + " " +
                STRING( Brtb_object.version,  "999999" ) + " " +
                STRING( Mdsp-wspace2,         "X(12)"  ) + " " +
                STRING( Brtb_object2.version,  "999999" ) + " " +
                STRING( Brtb_ver.description, "X(24)"  )
                .
              
        DISPLAY
          Mline FORMAT "X(78)"
        WITH FRAME version-frame
          NO-LABELS
          NO-ATTR-SPACE
          NO-BOX
          STREAM-IO
          .
        Mdiff = YES.
      END.  /* if Brtb_object.vers <> */     
    END.  /* if available Brtb_object */
        
  end.  /* for each Brtb_object */
  
  IF NOT Mdiff THEN
    DISPLAY Mmsg WITH FRAME no-diff-frame.
  ELSE
    Mdiff = NO.

  {rtb/g/rtbrpt2.i} /* close print destination */
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI DIALOG-1  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY Mwspace-id1 Mwspace-id2 
      WITH FRAME DIALOG-1.
  ENABLE Mwspace-id1 Mwspace-id2 
      WITH FRAME DIALOG-1.
  {&OPEN-BROWSERS-IN-QUERY-DIALOG-1}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

