/*------------------------------------------------------------------------
 
  File: schupd2a.p

  Description: Assign storage area number to metaschema fields
               during schema update.
               
               This file is separate from other schema update logic
               as the user may have a pre-V9 repository in which case
               these statements would not compile, since storage area
               metaschema fields would not be supported.
              
  Input Parameters:
      Update type ("File" or "Index") AS CHAR, Area name AS CHARACTER.

  Output Parameters:
      <none>

  Author: Randall K. Harp
  
  Created: Sept 1998

------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER Ptype AS CHARACTER No-UNDO.
DEFINE INPUT PARAMETER Parea AS CHARACTER NO-UNDO.

DEFINE SHARED BUFFER Bfile  FOR DICTDB._file.
DEFINE SHARED BUFFER Bindex FOR DICTDB._index.

/* --- Get associated _Area record --- */
FIND DICTDB._Area WHERE DICTDB._Area._Area-name = Parea NO-ERROR.

IF AVAILABLE DICTDB._Area
THEN DO:
  IF Ptype = "File" THEN
    Bfile._ianum = DICTDB._Area._Area-number.

  IF Ptype = "Index" THEN
    Bindex._ianum = DICTDB._Area._Area-number.
END.

RETURN.
