&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
/*------------------------------------------------------------------------

  _upddsa.w Roundtable Setup and Update subroutine.
  
  Called by _update.w.

  Allows new tables and indices to be assigned to database storage
  areas during update/install.

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBulder.       */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
/* Parameters Definitions ---                                           */
DEFINE INPUT PARAMETER Parea-dbs AS CHARACTER NO-UNDO.


/* Shared Variable Definitions ---                                       */
DEFINE SHARED TEMP-TABLE Tareas
   FIELD dbase      AS CHARACTER FORMAT "x(51)"
   FIELD table-name AS CHARACTER FORMAT "x(32)" LABEL "Table"
   FIELD object     AS CHARACTER FORMAT "x(40)" LABEL "Object"
   FIELD obj-type   AS CHARACTER                LABEL "Type"
   FIELD area-name  AS CHARACTER FORMAT "x(32)" LABEL "Area"
   FIELD df-file    AS CHARACTER.

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE Mareas AS CHARACTER NO-UNDO.

DEFINE TEMP-TABLE Tsorts NO-UNDO
   FIELD sort-column  AS CHARACTER
   FIELD sorted       AS LOGICAL
   FIELD desc-sort    AS LOGICAL
   INDEX sort-column IS PRIMARY sort-column. 

/* --- Define local widgets --- */
DEFINE QUERY BROWSE-1 FOR Tareas.

DEFINE BROWSE BROWSE-1 QUERY BROWSE-1 DISPLAY
  Tareas.table-name
  Tareas.object
&IF "{&WINDOW-SYSTEM}" = "TTY" &THEN
  FORMAT "x(20)"
&ELSE
  FORMAT "X(30)"
&ENDIF
  Tareas.obj-type
  Tareas.area-name
ENABLE
  Tareas.area-name
  VALIDATE(CAN-DO(Mareas,Tareas.area-name),
           "Storage area does not exist in database")

WITH
  NO-ROW-MARKERS SEPARATORS MULTIPLE SIZE 71 BY 7.5.
  
DEFINE STREAM Sareas.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS CB-DB CB-Area BT-Assign BT-Done 
&Scoped-Define DISPLAYED-OBJECTS CB-DB CB-Area 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON BT-Assign 
     LABEL "Assign" 
     SIZE 10 BY 1.

DEFINE BUTTON BT-Done 
     LABEL "Done" 
     SIZE 10 BY 1.

DEFINE VARIABLE CB-Area AS CHARACTER FORMAT "X(32)":U 
     LABEL "Area" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     DROP-DOWN-LIST
     SIZE 24 BY 1 NO-UNDO.

DEFINE VARIABLE CB-DB AS CHARACTER FORMAT "X(51)":U 
     LABEL "DB" 
     VIEW-AS COMBO-BOX INNER-LINES 3
     DROP-DOWN-LIST
     SIZE 17 BY 1 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-Frame
     CB-DB AT ROW 1.95 COL 6 COLON-ALIGNED
     CB-Area AT ROW 1.95 COL 33 COLON-ALIGNED
     BT-Assign AT ROW 1.95 COL 60
     BT-Done AT ROW 12.19 COL 66
     SPACE(1.99) SKIP(0.66)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "DB Area Assignments"
         DEFAULT-BUTTON BT-Done.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
                                                                        */
ASSIGN 
       FRAME Dialog-Frame:SCROLLABLE       = FALSE
       FRAME Dialog-Frame:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
ON WINDOW-CLOSE OF FRAME Dialog-Frame /* DB Area Assignments */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-Assign
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-Assign Dialog-Frame
ON CHOOSE OF BT-Assign IN FRAME Dialog-Frame /* Assign */
DO:
  CREATE ALIAS DICTDB FOR DATABASE 
     VALUE(CB-DB:SCREEN-VALUE IN FRAME {&FRAME-NAME}).
  RUN assign_area.
  DELETE ALIAS DICTDB.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-Done
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-Done Dialog-Frame
ON CHOOSE OF BT-Done IN FRAME Dialog-Frame /* Done */
DO:
  /* --- Save db area assignments */
  RUN save_db_areas.
  APPLY "GO" TO FRAME {&FRAME-NAME}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CB-DB
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CB-DB Dialog-Frame
ON VALUE-CHANGED OF CB-DB IN FRAME Dialog-Frame /* DB */
DO:
  /* --- Reload browse with objects for selected db --- */
  OPEN QUERY BROWSE-1 
      FOR EACH Tareas WHERE Tareas.dbase = CB-DB:SCREEN-VALUE
                IN FRAME Dialog-Frame.
  /* --- Build list of existing storage areas for selected db --- */
  RUN get_areas.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.

ON 'START-SEARCH':U OF BROWSE BROWSE-1
DO:
  RUN sort_browse.
  RETURN.
END.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
    
    /* --- Load DB combo-box with appliacable dbs and position to 1st --- */
    CB-DB:LIST-ITEMS IN FRAME {&FRAME-NAME} = Parea-dbs.
    CB-DB:SCREEN-VALUE IN FRAME {&FRAME-NAME} = ENTRY(1,Parea-dbs).
    APPLY "VALUE-CHANGED" TO CB-DB IN FRAME {&FRAME-NAME}.

    /* --- Show area assignment frame (and wait for done) --- */
    FORM
      BROWSE-1 AT ROW 3.38 COL 4
    WITH FRAME Dialog-Frame.
    ASSIGN
      BROWSE-1:SENSITIVE IN FRAME Dialog-Frame               = TRUE
      BROWSE-1:EXPANDABLE IN FRAME {&FRAME-NAME}             = TRUE
      BROWSE-1:ALLOW-COLUMN-SEARCHING IN FRAME {&FRAME-NAME} = TRUE
      BROWSE-1:COLUMN-RESIZABLE IN FRAME Dialog-Frame        = TRUE.

  RUN build_sort_table.

  RUN enable_UI.
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE assign_area Dialog-Frame 
PROCEDURE assign_area :
/*------------------------------------------------------------------------------
  Purpose:     Assign displayed storage area to selected objects.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF VAR Mi         AS INTEGER NO-UNDO.
  DEF VAR Mselected  AS LOGICAL NO-UNDO.
  DEF VAR Mrecid     AS RECID   No-UNDO.

  DO Mi = 1 TO BROWSE-1:NUM-SELECTED-ROWS IN FRAME {&FRAME-NAME}:
    Mselected = BROWSE-1:FETCH-SELECTED-ROW(Mi) IN FRAME {&FRAME-NAME}.
    IF Mselected
    THEN DO:
      Mrecid = RECID(Tareas).
      FIND FIRST Tareas WHERE RECID(Tareas) = Mrecid
           EXCLUSIVE-LOCK.
      ASSIGN Tareas.area-name = CB-Area:SCREEN-VALUE IN FRAME {&FRAME-NAME}.
    END.
  END.
  Mselected = BROWSE-1:REFRESH() IN FRAME {&FRAME-NAME}.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE build_sort_table Dialog-Frame 
PROCEDURE build_sort_table :
/*------------------------------------------------------------------------------
  Purpose:     Build table for tracking sort order for browse columns
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mcol AS WIDGET-HANDLE NO-UNDO.
  
  Mcol = BROWSE BROWSE-1:FIRST-COLUMN.
  DO WHILE VALID-HANDLE(Mcol):
    CREATE Tsorts.
    ASSIGN Tsorts.sort-column = Mcol:NAME
           Tsorts.desc-sort   = NO.
    Mcol = Mcol:NEXT-COLUMN.
  END.

  RETURN.  

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY CB-DB CB-Area 
      WITH FRAME Dialog-Frame.
  ENABLE CB-DB CB-Area BT-Assign BT-Done 
      WITH FRAME Dialog-Frame.
  VIEW FRAME Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_areas Dialog-Frame 
PROCEDURE get_areas :
/*------------------------------------------------------------------------------
  Purpose:     Assign displayed storage area to selected objects.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mcurrdb AS CHARACTER NO-UNDO.
  
  /* --- Preserve DB alias --- */
  Mcurrdb = LDBNAME("DICTDB").
  DELETE ALIAS DICTDB.
  CREATE ALIAS DICTB FOR DATABASE
         VALUE(CB-DB:SCREEN-VALUE IN FRAME {&FRAME-NAME}).
  Mareas = "".

  FOR EACH DICTDB._Area
      WHERE DICTDB._Area._Area-number >= 6
        AND DICTDB._Area._Area-type = 6
      NO-LOCK:

    IF NOT CAN-DO(Mareas,DICTDB._Area._Area-name) THEN
      Mareas = IF Mareas = "" THEN
                 DICTDB._Area._Area-name
               ELSE
                 Mareas + "," + DICTDB._Area._Area-name.
  END.

  /* --- Load area combo-box with list --- */
  ASSIGN
    CB-Area:LIST-ITEMS IN FRAME {&FRAME-NAME}   = MAreas
    CB-Area:SCREEN-VALUE IN FRAME {&FRAME-NAME} = ENTRY(1,Mareas).

  /* --- Restore DB alias if it exists --- */
  IF Mcurrdb <> ""
  THEN DO:
    DELETE ALIAS DICTDB.
    CREATE ALIAS DICTDB FOR DATABASE VALUE(Mcurrdb).
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE save_db_areas Dialog-Frame 
PROCEDURE save_db_areas :
/*------------------------------------------------------------------------------
  Purpose:     Save db storage area assignments to disk for use during
               schema update.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  OUTPUT STREAM Sareas TO VALUE("rtb_idat~/dbareas").

  FOR EACH Tareas:
    /* --- No need to save default schema area assignments --- */
    IF Tareas.area-name <> "Schema Area" THEN 
      EXPORT STREAM Sareas Tareas.
    DELETE Tareas.
  END.
  
  OUTPUT STREAM Sareas CLOSE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE sort_browse Dialog-Frame 
PROCEDURE sort_browse :
/*------------------------------------------------------------------------------
  Purpose:     Sort DB areas browse by current column
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mwhere  AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE Mcol    AS WIDGET-HANDLE NO-UNDO.
  DEFINE VARIABLE MhQuery AS WIDGET-HANDLE NO-UNDO.
  
  ASSIGN
    Mcol    = BROWSE BROWSE-1:CURRENT-COLUMN
    MhQuery = QUERY BROWSE-1:HANDLE.
  
  FIND Tsorts WHERE Tsorts.sort-column = Mcol:NAME.
  ASSIGN
    Tsorts.desc-sort = IF Tsorts.sorted THEN
                         NOT(Tsorts.desc-sort)
                       ELSE
                         FALSE
    Tsorts.sorted    = TRUE
    Mwhere           = SUBSTITUTE("FOR EACH Tareas BY &1 &2",
                                  Tsorts.sort-column,
                                  (IF Tsorts.desc-sort THEN
                                     "DESCENDING"
                                   ELSE "")).
  
  MhQuery:QUERY-PREPARE(Mwhere).
  BROWSE BROWSE-1:QUERY = MhQuery.
  MhQuery:QUERY-OPEN.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

